#include "dialogs.h"


const char sep = '/';
unsigned int dlg15EditVal=0;
palette_dib		surfaceDib;

vram_bank *vramBank;

unsigned int lcdc_banks[5] =
{
	0x0080000,
	0x0090000,
	0x0094000,
	0x0098000,
	0x00A0000
};



// Configuration dialog callback
BOOL CALLBACK DlgProc5(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam) {
	//static char stemp[64];
	int i;
	HWND hCmb;

   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);
			hCmb = GetDlgItem(hdlg,IDC_EDIT1);
			SetWindowText(hCmb,"Dualis\r\n Mic, 2006");
			wsprintf(szBuffer,"Components:\r\nARM946E-S\tR%d\r\nMMU\t\tR%d\r\nGPU\t\tR%d\r\nInput\t\tR%d\r\nGUI\t\tR%d\r\n\r\nConsult the README if having any problems.",
				     arm9PluginVersion,mmuPluginVersion,gpuPluginVersion,inpPluginVersion,guiVersion);
			hCmb = GetDlgItem(hdlg,IDC_EDIT2);
			SetWindowText(hCmb,szBuffer);
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					EndDialog(hdlg, 0);
					return TRUE;

				case IDCANCEL:
					EndDialog(hdlg, 1);
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}



// Configuration dialog callback
BOOL CALLBACK DlgProc6(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam) {
	//static char stemp[64];
	int i;
	HWND hCmb,hSize1,hSize2;

   switch(msg) {
		case WM_INITDIALOG:
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					EndDialog(hdlg, 0);
					return TRUE;

				case IDCANCEL:
					EndDialog(hdlg, 1);
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}




// Memory viewer callback
BOOL CALLBACK DlgProc7(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam) {
	int i,j,k,l;
	HWND hCmb,hCtl,hSize2;
	HWND hScroll;
	static int mview=IDC_RADIO_B;
	int x,y;
	static unsigned int adrPick=0xffffffff;

   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			memdc = GetDC(hdlg);

			SelectObject(memdc, font);
			SetBkColor(memdc,GetSysColor(COLOR_MENU));
			SetTextColor(memdc,RGB(128,20,20));

			hCmb = GetDlgItem(hdlg,IDC_COMBO_MEM);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x00000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x00800000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x02000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x02004000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04001000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x05000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x05000400");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x06000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x06200000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x06800000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x07000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x08000000");
			SendMessage(hCmb,CB_SETCURSEL,4,0);
			EnableWindow(hCmb,TRUE);

			//SendMessage(hCmb,CB_GETCOMBOBOXINFO,0,&cbnfo);

			memviewScroll.hwnd = GetDlgItem(hdlg, IDC_SCROLLBAR1);
			memviewScroll.set_range(0,0x0FFFFFFF);
			memviewScroll.set_page_size(0x100);
			memviewScroll.set_pos(memviewScroll.pos);

			hCtl = GetDlgItem(hdlg,mview);
			SendMessage(hCtl,BM_SETCHECK,1,0);

			x = y = -1;

			return TRUE;


		case WM_SIZE:
			return 0;

		case WM_LBUTTONDOWN:
			x = LOWORD(lParam);
			y = HIWORD(lParam);
			// 78,114  240,276
			if ((x>=78) && (y>=113) && (x<240) && (y<276))
			{
				x -= 78;
				y -= 113;
				x /= 20;
				y /= 14;

				adrPick = j = ((memviewScroll.pos + y)<<3) + (x&4);
				if (romLoaded)
				{
					k = mmu_read_word(j) | (mmu_read_word(j+2)<<16);
					//l = mmu_read_word(j+(i<<3)+4)|(mmu_read_word(j+(i<<3)+6)<<16);
				} else
					k = l = 0;

				wsprintf(szBuffer,"0x%08x",j);
				hCtl = GetDlgItem(hdlg,IDC_COMBO_MEM);
				SetWindowText(hCtl,szBuffer);

				wsprintf(szBuffer,"0x%08x",k);
				hCtl = GetDlgItem(hdlg,IDC_EDIT1);
				SetWindowText(hCtl,szBuffer);
				//MessageBox(NULL,szBuffer,"foo",MB_OK);

			}

			break;

		case WM_VSCROLL:
			if ((HWND)lParam != memviewScroll.hwnd)
				break;
			memviewScroll.get_pos();
			switch (LOWORD(wParam))
			{
				case SB_TOP:
					memviewScroll.pos = 0;
					break;

				case SB_LINEUP:
					if (memviewScroll.pos > 0)
						memviewScroll.pos--;
					break;
				case SB_PAGEUP:
					if (memviewScroll.pos > 12)
						memviewScroll.pos -= 12;
					break;

				case SB_THUMBPOSITION:
					memviewScroll.pos = HIWORD(wParam);
					break;

				case SB_THUMBTRACK:
					memviewScroll.pos = memviewScroll.get_tracker_pos();
					break;

				case SB_LINEDOWN:
					if (memviewScroll.pos < 0x0FFFFF80)
						memviewScroll.pos++;
					break;
				case SB_PAGEDOWN:
					if (memviewScroll.pos < 0x0FFFFFC0)
						memviewScroll.pos += 12;
					break;

				case SB_BOTTOM:
					memviewScroll.pos = 0x0FFFFF80;
					break;
			}
			memviewScroll.set_pos(memviewScroll.pos);
			InvalidateRect(hdlg,NULL,TRUE);
			break;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);

			MoveToEx(memdc, 8, 58+44, NULL);
			LineTo(memdc, 304,58+44);

			hCtl = GetDlgItem(hdlg,IDC_RADIO_B);
			if (SendMessage(hCtl,BM_GETCHECK,0,0) == BST_CHECKED)
			{
				mview = IDC_RADIO_B;
			} else
			{
				hCtl = GetDlgItem(hdlg,IDC_RADIO_H);
				if (SendMessage(hCtl,BM_GETCHECK,0,0) == BST_CHECKED)
				{
					mview = IDC_RADIO_H;
				} else
					mview = IDC_RADIO_W;
			}

			j = memviewScroll.pos<<3;
			for (i=0; i<12; i++)
			{
				//if (i>12) break;
				if (romLoaded)
				{
					k = mmu_read_word(j+(i<<3))|(mmu_read_word(j+(i<<3)+2)<<16);
					l = mmu_read_word(j+(i<<3)+4)|(mmu_read_word(j+(i<<3)+6)<<16);
				} else
					k = l = 0;

				if (mview == IDC_RADIO_B)
				{
					wsprintf(szBuffer,"%08X: %02X %02X %02X %02X %02X %02X %02X %02X",
										j+(i<<3),(k)&255,(k>>8)&255,(k>>16)&255,(k>>24)&255,
										(l)&255,(l>>8)&255,(l>>16)&255,(l>>24)&255);
				} else if (mview == IDC_RADIO_H)
				{
					wsprintf(szBuffer,"%08X: %04X  %04X  %04X  %04X",
										j+(i<<3),(k)&0xFFFF,(k>>16)&0xFFFF,
										(l)&0xFFFF,(l>>16)&0xFFFF);
				} else
				{
					wsprintf(szBuffer,"%08X: %08X    %08X",
							j+(i<<3),k,l);
				}
				TextOut(memdc,8,64+50+(i*14),szBuffer,lstrlen(szBuffer));
			}
			EndPaint(hdlg,&ps);
			break;


		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_RADIO_B:
				case IDC_RADIO_H:
				case IDC_RADIO_W:
					InvalidateRect(hdlg,NULL,TRUE);
					break;

				case IDC_BUTTON1:
					hCmb = GetDlgItem(hdlg,IDC_COMBO_MEM);

					GetWindowText(hCmb,szBuffer3,12);
					if (strlen(szBuffer3))
					{
						if (szBuffer3[0] != '0')
						{
							strcpy(szBuffer,"0x");
							strcat(szBuffer,szBuffer3);
						} else
						{
							strcpy(szBuffer,szBuffer3);
						}
						memviewScroll.pos = strtoul(szBuffer,NULL,0) >> 3; // & (~7);
						//wsprintf(szBuffer,"%x",memviewScroll.pos);
						//MessageBox(NULL,szBuffer,"EDIT contains",MB_OK);

						memviewScroll.set_pos(memviewScroll.pos); //memview_lut[SendMessage(hCmb,CB_GETCURSEL,0,0)]>>3);
						memviewScroll.set_tracker_pos(memviewScroll.pos);
						InvalidateRect(hdlg,NULL,TRUE);
					}
					break;

				case IDC_BUTTON2:
					hCtl = GetDlgItem(hdlg,IDC_EDIT1);

					if (adrPick != 0xffffffff)
					{
						GetWindowText(hCtl,szBuffer3,12);
						if (strlen(szBuffer3))
						{
							if (szBuffer3[0] != '0')
							{
								strcpy(szBuffer,"0x");
								strcat(szBuffer,szBuffer3);
							} else
							{
								strcpy(szBuffer,szBuffer3);
							}
							mmu_write_dword(adrPick, strtoul(szBuffer,NULL,0));

							//wsprintf(szBuffer,"Writing %08x to %08x",0,adrPick);
							//MessageBox(NULL,szBuffer,"foo",MB_OK);

							//memviewScroll.set_pos(memviewScroll.pos); //memview_lut[SendMessage(hCmb,CB_GETCURSEL,0,0)]>>3);
							//memviewScroll.set_tracker_pos(memviewScroll.pos);
							InvalidateRect(hdlg,NULL,TRUE);
						}
					}
					break;

				case IDOK:
					ReleaseDC(hdlg,memdc);
					EndDialog(hdlg, 0);
					windows[5].active = false;
					return TRUE;

				case IDCANCEL:
				case IDCLOSE:
					ReleaseDC(hdlg,memdc);
					EndDialog(hdlg, 1);
					windows[5].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}




// Debug console callback
BOOL CALLBACK DlgProc8(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam) {
	static char stemp[64];
	int i,j,k,l;
	HWND hCmb,hCtl,hSize2;
	HWND hScroll;

   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			dbgdc = GetDC(hdlg);

			SelectObject(dbgdc, font);
			SetBkColor(dbgdc,GetSysColor(COLOR_MENU));
			SetTextColor(dbgdc,RGB(128,20,20));

			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR2);
			ZeroMemory(&si, sizeof(si));
			si.cbSize = sizeof(si);
			si.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
			si.nMin   = 0;
			//si.nMax   = 0x0FFFFFFF;
			si.nPage  = 0x1;
			//si.nPos   = 0x00800000;
			si.nPos = dbgMsgPos;
			si.nMax   = (dbgMsgCount-1)>=0 ? (dbgMsgCount-1) : 0;
			SetScrollInfo(hScroll, SB_CTL, &si, TRUE);

			hCtl = GetDlgItem(hdlg,IDC_CHECK1);
			SendMessage(hCtl,BM_SETCHECK,1,0);

			return TRUE;


		case WM_SIZE:
			return 0;

		case WM_VSCROLL:
			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR2);
			if ((HWND)lParam != hScroll) break;
			dbgMsgPos = GetScrollPos(hScroll, SB_CTL);
			switch (LOWORD(wParam))
			{
				case SB_TOP:
						dbgMsgPos = 0;
						break;

				case SB_LINEUP:
						if (dbgMsgPos > 0)
								dbgMsgPos--;
						break;
				case SB_PAGEUP:
						if (dbgMsgPos > 1)
								dbgMsgPos -= 2;
						break;

				case SB_THUMBPOSITION:
						dbgMsgPos = HIWORD(wParam);
						break;

				case SB_THUMBTRACK:
						dbgMsgPos = HIWORD(wParam);
						break;

				case SB_LINEDOWN:
						if (dbgMsgPos < dbgMsgCount-1)
								dbgMsgPos++;
						break;
				case SB_PAGEDOWN:
						if (dbgMsgPos < dbgMsgCount-2)
								dbgMsgPos += 2;
						break;

				case SB_BOTTOM:
						dbgMsgPos = dbgMsgCount-1;
						break;
			}
			SetScrollPos(hScroll, SB_CTL, dbgMsgPos, TRUE);
			InvalidateRect(hdlg,NULL,TRUE);
			break;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);
			MoveToEx(dbgdc, 8, 36, NULL);
			LineTo(dbgdc, 256,36);
			j = dbgMsgPos;
			for (i=1; i<=dbgMsgCount; i++)
			{
				if (i>12) break;
				if (dbgMsgCount-(i+j) < 0) break;
				TextOut(dbgdc,8,40+((i-1)*14),dbgMessages[dbgMsgCount-(i+j)],lstrlen(dbgMessages[dbgMsgCount-(i+j)]));
			}
			EndPaint(hdlg,&ps);
			return 0;



		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_BUTTON1:
					dbgMsgCount = 0;
					dbgMsgPos = 0;
					si.nPos = dbgMsgPos;
					si.nMax   = (dbgMsgCount-1)>=0 ? (dbgMsgCount-1) : 0;
					hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
					SetScrollInfo(hScroll, SB_CTL, &si, TRUE);
					for (i=0; i<32; i++)
						dbgMessages[i][0] = '\0';
					InvalidateRect(hdlg,NULL,TRUE);
					break;

				case IDOK:
					ReleaseDC(hdlg,dbgdc);
					EndDialog(hdlg, 0);
					windows[4].active = false;
					return TRUE;

				case IDCANCEL:
				case IDCLOSE:
					ReleaseDC(hdlg,dbgdc);
					EndDialog(hdlg, 1);
					windows[4].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}



// Disassembler callback
BOOL CALLBACK DlgProc9(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam) {
	int				i,j,k,l,p,x,y,page,offset;
	unsigned int	op;
	HWND			hCmb,hCtl;
	HWND			hScroll;
	char			*lpsz,*token;
	HPEN			blackPen,whitePen;
	HBRUSH			whiteBrush;
	HWND			hDlg;
	static bool		isARM = true;
	static int		disMode = IDC_RADIO_AUTO;

   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			disdc = GetDC(hdlg);

			SelectObject(disdc, font);
			SetBkColor(disdc,colors[0]); ;
			SetTextColor(disdc,RGB(160,160,160));

			disasmScroll.hwnd = GetDlgItem(hdlg, IDC_SCROLLBAR1);
			disasmScroll.set_range(0,0x0FFFFFFF);
			disasmScroll.set_page_size(0x100);
			disasmScroll.set_pos(disasmScroll.pos);

			hCmb = GetDlgItem(hdlg,IDC_COMBO1);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x00000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x00800000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x02000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x02004000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x05000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x06000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x06200000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x06800000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x07000000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x08000000");
			SendMessage(hCmb,CB_SETCURSEL,3,0);
			EnableWindow(hCmb,TRUE);

			whitePen = CreatePen(PS_SOLID,0,colors[0]); //RGB(255,255,255));
			blackPen = CreatePen(PS_SOLID,0,RGB(0,0,0));

			hCtl = GetDlgItem(hdlg,disMode);
			SendMessage(hCtl,BM_SETCHECK,1,0);

			arm9_regs = (unsigned int*)cpu_get(CPU_REG);

			for (i=IDC_STATIC0; i<=IDC_STATIC15; i++)
			{
				hCtl = GetDlgItem(hdlg,i);
				SendMessage(hCtl, WM_SETFONT, (WPARAM)font, TRUE);
				if (i<IDC_STATIC10)
					wsprintf(szBuffer,"R%d:  0x%08X",i-IDC_STATIC0,arm9_regs[i-IDC_STATIC0]);
				else
					wsprintf(szBuffer,"R%d: 0x%08X",i-IDC_STATIC0,arm9_regs[i-IDC_STATIC0]);
				SetWindowText(hCtl,szBuffer);
			}

			j = 0x80000000;
			for (i=IDC_STATIC_N; i<=IDC_STATIC_N4; i++)
			{
				hCtl = GetDlgItem(hdlg,i);
				EnableWindow(hCtl,(arm9_regs[16]&j)!=0);
				j >>= 1;
			}
			hCtl = GetDlgItem(hdlg,IDC_STATIC_N5);
			EnableWindow(hCtl,(arm9_regs[16]&0x8000000)!=0);
			hCtl = GetDlgItem(hdlg,IDC_STATIC_N6);
			EnableWindow(hCtl,(arm9_regs[16]&0x20)!=0);

			return TRUE;


		case WM_SIZE:
			return 0;

		// Handle leftbutton clicks on the register list
		case WM_LBUTTONDOWN:
			x = LOWORD(lParam);
			y = HIWORD(lParam);
			if ((x>=454) && (y>=37))
			{
				x -= 454;
				y -= 37;
				y /= 18;
				if (y<16)
				{
					dlg15EditVal = arm9_regs[y];
					DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_DIALOG15),hdlg,DlgProc15,NULL);
					arm9_regs[y] = dlg15EditVal;
				}
			}
			break;

		case WM_VSCROLL:
			if ((HWND)lParam != disasmScroll.hwnd) break;
			disasmScroll.get_pos();
			switch (LOWORD(wParam))
			{
				case SB_TOP:
						disasmScroll.pos = 0;
						break;

				case SB_LINEUP:
						if (disasmScroll.pos > 0)
								disasmScroll.pos--;
						break;
				case SB_PAGEUP:
						if (disasmScroll.pos > 12)
								disasmScroll.pos -= 12;
						break;

				case SB_THUMBPOSITION:
						disasmScroll.pos = HIWORD(wParam);
						break;

				case SB_THUMBTRACK:
					disasmScroll.get_tracker_pos();
					break;

				case SB_LINEDOWN:
						if (disasmScroll.pos<0x0FFFFF80)
								disasmScroll.pos++;
						break;
				case SB_PAGEDOWN:
						if (disasmScroll.pos<0x0FFFFFC0)
								disasmScroll.pos += 12;
						break;

				case SB_BOTTOM:
						disasmScroll.pos = 0x0FFFFF80;
						break;
			}
			disasmScroll.set_pos(disasmScroll.pos);
			rect2.top = 90;
			rect2.left = 8;
			rect2.right = 360;
			rect2.bottom = -1;
			InvalidateRect(hdlg,&rect2,FALSE);
			break;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);

			arm9_regs = (unsigned int*)cpu_get(CPU_REG);

			for (i=IDC_STATIC0; i<=IDC_STATIC15; i++)
			{
				hCtl = GetDlgItem(hdlg,i);
				SendMessage(hCtl, WM_SETFONT, (WPARAM)font, TRUE);
				if (i<IDC_STATIC10)
					wsprintf(szBuffer,"R%d:  0x%08X",i-IDC_STATIC0,arm9_regs[i-IDC_STATIC0]);
				else
					wsprintf(szBuffer,"R%d: 0x%08X",i-IDC_STATIC0,arm9_regs[i-IDC_STATIC0]);
				SetWindowText(hCtl,szBuffer);
			}

			j = 0x80000000;
			for (i=IDC_STATIC_N; i<=IDC_STATIC_N4; i++)
			{
				hCtl = GetDlgItem(hdlg,i);
				EnableWindow(hCtl,(arm9_regs[16]&j)!=0);
				j >>= 1;
			}
			hCtl = GetDlgItem(hdlg,IDC_STATIC_N5);
			EnableWindow(hCtl,(arm9_regs[16]&0x8000000)!=0);
			hCtl = GetDlgItem(hdlg,IDC_STATIC_N6);
			EnableWindow(hCtl,(arm9_regs[16]&0x20)!=0);

			whiteBrush = CreateSolidBrush(colors[0]);
			SelectObject(disdc,whiteBrush);
			Rectangle(disdc,8,91,416,348);
			lpsz = &szBuffer[0];

			hCtl = GetDlgItem(hdlg,IDC_RADIO_AUTO);
			if (SendMessage(hCtl,BM_GETCHECK,0,0) == BST_CHECKED)
			{
				isARM = ((arm9_regs[16]&0x20)==0);
			} else
			{
				hCtl = GetDlgItem(hdlg,IDC_RADIO_ARM);
				isARM = (SendMessage(hCtl,BM_GETCHECK,0,0) == BST_CHECKED);
			}

			j = disasmScroll.pos<<2;
			for (i=0; i<18; i++)
			{
				page = j>>20;
				if (isARM)
					offset = j&0xFFFFC;
				else
					offset = j&0xFFFFE;
				k = j;
				if (pageTable[page])
				{
					j += disassemble(lpsz,(page<<20)+offset,(unsigned int*)(pageTable[page]+offset),isARM);
				} else
				{
					op = 0;
					j += disassemble(lpsz,(page<<20)+offset,&op,isARM);
				}


				token = strtok(lpsz,&sep);
				x = lstrlen(token);
				if (k == arm9_regs[15])
				{
					SetBkColor(disdc,colors[7]);
					SetTextColor(disdc,colors[0]);
				} else
					SetTextColor(disdc,colors[1]);
				TextOut(disdc,10,96+(i*14),token,x);
				for (p=1; p<16; p++)
				{
					token = strtok(NULL,&sep);
					if (token==NULL) break;
					if (k != arm9_regs[15])
					{
						if (p==1)
							SetTextColor(disdc,colors[1]);
						else if (p==2)
							SetTextColor(disdc,colors[2]);
						else if ((token[0] == 'r'))
							SetTextColor(disdc,colors[3]);
						else if (token[0]=='#')
							SetTextColor(disdc,colors[4]);
						else if ((token[0]==']')||(token[0]=='[')||(token[0]=='}')||(token[0]=='{'))
							SetTextColor(disdc,colors[6]);
						else if (token[0]==';')
							SetTextColor(disdc,colors[5]);
						else
							SetTextColor(disdc,colors[7]);
					}
					TextOut(disdc,10+(x*7),96+(i*14),token,lstrlen(token));
					x += lstrlen(token);
				}
				if (k == arm9_regs[15])
					SetBkColor(disdc,colors[0]);
			}
			DeleteObject(whiteBrush);
			EndPaint(hdlg,&ps);
			break;


		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_RADIO_ARM:
				case IDC_RADIO_TMB:
				case IDC_RADIO_AUTO:
					InvalidateRect(hdlg,NULL,TRUE);
					break;

				case IDC_BUTTON1:
					hCmb = GetDlgItem(hdlg,IDC_COMBO1);

					GetWindowText(hCmb,szBuffer3,12);
					if (strlen(szBuffer3))
					{
						if (szBuffer3[0] != '0')
						{
							strcpy(szBuffer,"0x");
							strcat(szBuffer,szBuffer3);
						} else
						{
							strcpy(szBuffer,szBuffer3);
						}
						disasmScroll.pos = strtoul(szBuffer,NULL,0) >> 2;

						disasmScroll.set_pos(disasmScroll.pos);
						disasmScroll.set_tracker_pos(disasmScroll.pos);
						InvalidateRect(hdlg,NULL,TRUE);
					}
					break;

				case IDC_BUTTON4:
					arm9_regs = (unsigned int*)cpu_get(CPU_REG);
					disasmScroll.pos = arm9_regs[15]>>2;
					disasmScroll.set_pos(disasmScroll.pos);
					disasmScroll.set_tracker_pos(disasmScroll.pos);
					rect2.top = 90;
					rect2.left = 8;
					rect2.right = 360;
					rect2.bottom = -1;
					InvalidateRect(hdlg,&rect2,FALSE);
					break;

				case IDOK:
					ReleaseDC(hdlg,disdc);
					EndDialog(hdlg, 0);
					windows[6].active = false;
					return TRUE;

				case IDCANCEL:
				case IDCLOSE:
					ReleaseDC(hdlg,disdc);
					EndDialog(hdlg, 1);
					windows[6].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}





// Palette viewer callback
BOOL CALLBACK DlgProc10(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam) {
	static int	palSel=0,colSel=0,extBank=0,extSet=0,extPal=0;
	int			i,j,k,l;
	HWND		hCmb,hCtl,hSize2;
	HWND		hScroll;
	HBRUSH		hbrCol;
	short int	currCol;
	unsigned short int *p;
	unsigned char *vramptr;
	HANDLE		hFile;
	DWORD		dwBytesRead;
	static char szRIFF[]="RIFF",szPAL[]="PAL ",szdata[]="data";


   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			hCmb = GetDlgItem(hdlg,IDC_COMBO1);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Bank E");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Bank F");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Bank G");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Bank H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Bank I");
			SendMessage(hCmb,CB_SETCURSEL,extBank,0);

			hCmb = GetDlgItem(hdlg,IDC_COMBO2);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Set 0");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Set 1");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Set 2");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Set 3");
			SendMessage(hCmb,CB_SETCURSEL,extSet,0);

			hCmb = GetDlgItem(hdlg,IDC_COMBO3);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Frame");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Second");
			SendMessage(hCmb,CB_SETCURSEL,palUpdateMode&3,0);

			hCtl = GetDlgItem(hdlg,IDC_CHECK1);
			SendMessage(hCmb,BM_SETCHECK,(palUpdateMode&4)?BST_CHECKED:BST_UNCHECKED,0);

			paldc = GetDC(hdlg);

			SelectObject(paldc, font);
			SetBkColor(paldc,GetSysColor(COLOR_MENU));
			SetTextColor(paldc,RGB(128,20,20));

			if (romLoaded)
			{
				vramptr = (unsigned char*)gpu_get(GPU_MEMORY);
				currCol = mmu_read_word(0x5000000+(palSel<<10)+(colSel<<1));
			} else
			{
				vramptr = NULL;
				currCol = (short)GetSysColor(COLOR_MENU);
			}

			for (i=0; i<3; i++)
			{
				hCtl = GetDlgItem(hdlg,IDC_SLIDER1+i);
				SendMessage(hCtl,TBM_SETRANGE,FALSE,MAKELONG(0,31));
				SendMessage(hCtl,TBM_SETPOS,TRUE,currCol&31);
				hCtl = GetDlgItem(hdlg,IDC_STATIC_R+i);
				wsprintf(szBuffer,"%d",currCol&31);
				SetWindowText(hCtl,szBuffer);

				currCol >>= 5;
			}

			hCtl = GetDlgItem(hdlg,IDC_SLIDER4);
			SendMessage(hCtl,TBM_SETRANGE,FALSE,MAKELONG(0,15));
			SendMessage(hCtl,TBM_SETPOS,TRUE,extPal);
			hCtl = GetDlgItem(hdlg,IDC_STATIC_E);
			wsprintf(szBuffer,"%d",extPal);
			SetWindowText(hCtl,szBuffer);

			return TRUE;


		case WM_SIZE:
			return 0;

		case WM_HSCROLL:
			if (!romLoaded) return 0;
			for (i=0; i<3; i++)
			{
				hScroll = GetDlgItem(hdlg,IDC_SLIDER1+i);
				if ((HWND)lParam == hScroll) break;
			}
			if (i == 3)
			{
				hScroll = GetDlgItem(hdlg,IDC_SLIDER4);
				if ((HWND)lParam == hScroll)
				{
					extPal = SendMessage(hScroll,TBM_GETPOS,0,0);
					hCtl = GetDlgItem(hdlg,IDC_STATIC_E);
					wsprintf(szBuffer,"%d",extPal);
					SetWindowText(hCtl,szBuffer);

					if (palSel == 2)
					{
						if ((extBank==0)||(extBank==3))
							i = extSet;
						else
							i = extSet & 1;
						p = (unsigned short int*)(pageTable[0x60] + (lcdc_banks[extBank]&0xFFFFF) + (i<<13) + (extPal<<9) + (colSel<<1));
						currCol = *p;
						for (i=0; i<3; i++)
						{
							hCtl = GetDlgItem(hdlg,IDC_SLIDER1+i);
							//SendMessage(hCtl,TBM_SETRANGE,FALSE,MAKELONG(0,31));
							SendMessage(hCtl,TBM_SETPOS,TRUE,currCol&31);
							hCtl = GetDlgItem(hdlg,IDC_STATIC_R+i);
							wsprintf(szBuffer,"%d",currCol&31);
							SetWindowText(hCtl,szBuffer);

							currCol >>= 5;
						}
					}

					InvalidateRect(hdlg,NULL,FALSE);
				}
				return 0;
			}
			j = SendMessage(hScroll,TBM_GETPOS,0,0);
			currCol = mmu_read_word(0x5000000+(palSel<<10)+(colSel<<1));
			mmu_write_word(0x5000000+(palSel<<10)+(colSel<<1),(currCol&(~(31<<(i*5))))|(j<<(i*5)));
			hCtl = GetDlgItem(hdlg,IDC_STATIC_R+i);
			wsprintf(szBuffer,"%d",j);
			SetWindowText(hCtl,szBuffer);
			rect2.left = 8;
			rect2.top = 8;
			rect2.right = 80;
			rect2.bottom = 80;
			InvalidateRect(hdlg,&rect2,FALSE);
			return 0;

		case WM_LBUTTONDOWN:
			i = LOWORD(lParam);
			j = HIWORD(lParam);
			k = -1;
			if ((j>=116)&&(j<=276))
			{
				if ((i>=MAINPAL_POSX)&&(i<=MAINPAL_POSX+128))
					k = 0;
				else if ((i>=SUBPAL_POSX)&&(i<=SUBPAL_POSX+128))
					k = 1;
			}
			if (k == -1)
				if ((j>=116+80)&&(j<=276))
					if ((i>=EXTPAL_POSX)&&(i<=EXTPAL_POSX+128))
						k = 2;
			if (k != -1)
			{
				palSel = k;
				colSel = ((j-116)/5)<<4;
				if (i>=EXTPAL_POSX)
				{
					i -= EXTPAL_POSX;
					colSel -= 256;
				} else if (i>=SUBPAL_POSX)
					i -= SUBPAL_POSX;
				else
					i -= MAINPAL_POSX;
				colSel += (i>>3);

				if (romLoaded)
				{
					if (palSel==2)
					{
						if ((extBank==0)||(extBank==3))
							i = extSet;
						else
							i = extSet & 1;
						currCol = *(unsigned short int*)(pageTable[0x60] + (lcdc_banks[extBank]&0xFFFFF) + (i<<13) + (extPal<<9) + (colSel<<1));
					} else
					{
						currCol = mmu_read_word(0x5000000+(palSel<<10)+(colSel<<1));
					}
				} else
				{
					currCol = (short)GetSysColor(COLOR_MENU);
					currCol = (currCol>>3)&31;
					currCol |= (currCol<<5)|(currCol<<10);
				}

				for (i=0; i<3; i++)
				{
					hCtl = GetDlgItem(hdlg,IDC_SLIDER1+i);
					SendMessage(hCtl,TBM_SETPOS,TRUE,currCol&31);
					hCtl = GetDlgItem(hdlg,IDC_STATIC_R+i);
					wsprintf(szBuffer,"%d",currCol&31);
					SetWindowText(hCtl,szBuffer);
					currCol >>= 5;
				}

				rect2.left = 8;
				rect2.top = 8;
				rect2.right = 200;
				rect2.bottom = 80;
				InvalidateRect(hdlg,&rect2,FALSE);
			}
			break;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);
			MoveToEx(paldc, 8, 82, NULL);
			LineTo(paldc, 440,82);

			if (romLoaded)
			{
				if (palSel==2)
				{
					if ((extBank==0)||(extBank==3))
						i = extSet;
					else
						i = extSet & 1;
					currCol = *(unsigned short int*)(pageTable[0x60] + (lcdc_banks[extBank]&0xFFFFF) + (i<<13) + (extPal<<9) + (colSel<<1));

				} else
				{
					currCol = mmu_read_word(0x5000000+(palSel<<10)+(colSel<<1));
				}
			} else
			{
				currCol = GetSysColor(COLOR_MENU);
				currCol = (currCol>>3)&31;
				currCol |= (currCol<<5)|(currCol<<10);
			}
			hbrCol = CreateSolidBrush(RGB((currCol&31)<<3,(currCol>>2)&0xF8,(currCol>>7)&0xF8));
			SelectObject(paldc,hbrCol);
			Rectangle(paldc,8,16+10,56,64+10);
			DeleteObject(hbrCol);

			if (palSel==0)
			{
				if (colSel<256)
					wsprintf(szBuffer,"Main BG color %d",colSel);
				else
					wsprintf(szBuffer,"Main OBJ color %d",colSel-256);
			} else if (palSel==1)
			{
				if (colSel<256)
					wsprintf(szBuffer,"Sub BG color %d",colSel);
				else
					wsprintf(szBuffer,"Sub OBJ color %d",colSel-256);
			} else
			{
				wsprintf(szBuffer,"Extended color %d",colSel);
			}
			hCtl = GetDlgItem(hdlg,IDC_STATIC_C);
			SetWindowText(hCtl,szBuffer);

			wsprintf(szBuffer,"R:%d  G:%d  B:%d",currCol&31,(currCol>>5)&31,(currCol>>10)&31);
			hCtl = GetDlgItem(hdlg,IDC_STATIC_RGB);
			SetWindowText(hCtl,szBuffer);

			if (romLoaded)
			{
				pdib = (palette_dib*)gpu_get(GPU_PALETTE);
				StretchDIBits(paldc,MAINPAL_POSX,116,128,160,0,32,16,32,
							  pdib->data,(BITMAPINFO*)&pdib->bih,DIB_RGB_COLORS,SRCCOPY);
				StretchDIBits(paldc,SUBPAL_POSX,116,128,160,0,0,16,32,
							  pdib->data,(BITMAPINFO*)&pdib->bih,DIB_RGB_COLORS,SRCCOPY);

				if ((extBank==0)||(extBank==3))
					i = extSet;
				else
					i = extSet & 1;
				p = (unsigned short int*)(pageTable[0x60] + (lcdc_banks[extBank]&0xFFFFF) + (i<<13) + (extPal<<9));
				pdib->data = (char*)p;
				pdib->bih.biHeight = -16;
				StretchDIBits(paldc,EXTPAL_POSX,116+80,128,80,0,0,16,16,
							  pdib->data,(BITMAPINFO*)&pdib->bih,DIB_RGB_COLORS,SRCCOPY);
			}

			for (i=0; i<=16; i++)
			{
				MoveToEx(paldc,8+(i*8),116,NULL);
				LineTo(paldc,8+(i*8),276);
				MoveToEx(paldc,SUBPAL_POSX+(i*8),116,NULL);
				LineTo(paldc,SUBPAL_POSX+(i*8),276);
				MoveToEx(paldc,EXTPAL_POSX+(i*8),116+80,NULL);
				LineTo(paldc,EXTPAL_POSX+(i*8),276);
			}

			for (i=0; i<=32; i++)
			{
				MoveToEx(paldc,MAINPAL_POSX,116+(i*5),NULL);
				LineTo(paldc,MAINPAL_POSX+128,116+(i*5));
				MoveToEx(paldc,SUBPAL_POSX,116+(i*5),NULL);
				LineTo(paldc,SUBPAL_POSX+128,116+(i*5));
				if (i>=16)
				{
					MoveToEx(paldc,EXTPAL_POSX,116+(i*5),NULL);
					LineTo(paldc,EXTPAL_POSX+128,116+(i*5));
				}
			}

			EndPaint(hdlg,&ps);
			return 0;



		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_COMBO1:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO1);
						extBank = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO2:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO2);
						extSet = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO3:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO3);
						palUpdateMode &= ~3;
						palUpdateMode |= SendMessage(hCmb,CB_GETCURSEL,0,0);
					}
					return 0;

				case IDC_CHECK1:
					hCtl = GetDlgItem(hdlg,IDC_CHECK1);
					if (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED)
						palUpdateMode |= 4;
					else
						palUpdateMode &= ~4;
					return 0;

				case IDOK:
					ReleaseDC(hdlg,paldc);
					EndDialog(hdlg, 0);
					windows[3].active = false;
					return TRUE;

					case ID_PAL_LOAD:	// Load palette
						if (!romLoaded)
							return 0;
						if (!get_openfilename(szFnBuffer,"Load Palette","MS PAL files (*.pal)\0*.pal\0"))
						{
							return 0;
						}
						hFile = CreateFile(szFnBuffer, GENERIC_READ, 0, NULL, OPEN_EXISTING,
										   FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,
										   NULL);
						if (hFile == INVALID_HANDLE_VALUE)
							return 0;

						if (GetFileSize(hFile,NULL) != 1048)
						{
							CloseHandle(hFile);
							return 0;
						}
						if (romLoaded)
						{
							ReadFile(hFile,&mspal,24,&dwBytesRead,NULL);
							if (palSel == 2)
							{
								if ((extBank==0)||(extBank==3))
									i = extSet;
								else
									i = extSet & 1;
								p = (unsigned short int*)(pageTable[0x68] + (lcdc_banks[extBank]&0xFFFFF) + (i<<13) + (extPal<<9));

							} else
								p = (unsigned short int*)(pageTable[0x50] + (palSel<<10) + ((colSel&0x100)<<1));
							i = mspal.sNumColors;
							if (i>256) i = 256;
							ReadFile(hFile,mspal.cData,i*4,&dwBytesRead,NULL);
							CloseHandle(hFile);
							k = 0;
							for (j=0; j<i; j++)
							{
								p[j] = (mspal.cData[k+0]>>3) |
									   ((mspal.cData[k+1]>>3)<<5) |
									   ((mspal.cData[k+2]>>3)<<10);
								k += 4;
							}
							rect2.left = 8;
							rect2.top = 8;
							rect2.right = 200;
							rect2.bottom = 80;
							InvalidateRect(hdlg,&rect2,FALSE);
						}
						return 0;

					case ID_PAL_SAVE:	// Save palette
						if (!romLoaded)
							return 0;
						if (!get_savefilename(szFnBuffer,"Save Palette","MS PAL files (*.pal)\0*.pal\0"))
						{
							return 0;
						}
						hFile = CreateFile(szFnBuffer, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
										   FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,
										   NULL);
						if (hFile == INVALID_HANDLE_VALUE)
							return 0;

						if (romLoaded)
						{
							mspal.dwSignature = *(DWORD*)&szRIFF;
							mspal.dwFileLength = 1040;
							mspal.dwRIFFType = *(DWORD*)&szPAL;
							mspal.dwRIFFSignature = *(DWORD*)&szdata;
							mspal.dwChunkSize = 1028;
							mspal.sPalVersion = 0x300;
							mspal.sNumColors = 256;

							if (palSel == 2)
							{
								if ((extBank==0)||(extBank==3))
									i = extSet;
								else
									i = extSet & 1;
								p = (unsigned short int*)(pageTable[0x68] + (lcdc_banks[extBank]&0xFFFFF) + (i<<13) + (extPal<<9));

							} else
								p = (unsigned short int*)(pageTable[0x50] + (palSel<<10) + ((colSel&0x100)<<1));

							k = 0;
							for (j=0; j<256; j++)
							{
								mspal.cData[k+0] = (p[j]&0x1f)<<3;
								mspal.cData[k+1] = (p[j]&0x3e0)>>2;
								mspal.cData[k+2] = (p[j]&0x7c00)>>7;
								mspal.cData[k+3] = 0;
								k += 4;
							}
							WriteFile(hFile,&mspal,1048,&dwBytesRead,NULL);
							CloseHandle(hFile);
						}
						return 0;

				case IDCANCEL:
					ReleaseDC(hdlg,paldc);
					EndDialog(hdlg, 1);
					windows[3].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}



// IO viewer callback
BOOL CALLBACK DlgProc11(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	//static char stemp[64];
	int i,j,k,l;
	HWND hCmb,hCtl,hSize2;
	HWND hScroll;
	//static int mview=IDC_RADIO_B;
	static int ioRegSel=0;
	unsigned short int regVal;

   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			iodc = GetDC(hdlg);

			hCmb = GetDlgItem(hdlg,IDC_COMBO3);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000000 - DISPCNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000002 - DISPCNT_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000004 - DISPSTAT");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000006 - VCOUNT");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000008 - BG0CNT");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400000A - BG1CNT");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400000C - BG2CNT");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400000E - BG3CNT");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000010 - BG0HOFS");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000012 - BG0VOFS");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000014 - BG1HOFS");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000016 - BG1VOFS");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000018 - BG2HOFS");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400001A - BG2VOFS");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400001C - BG3HOFS");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400001E - BG3VOFS");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000020 - BG2PA");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000022 - BG2PB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000024 - BG2PC");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000026 - BG2PD");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000028 - BG2X_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400002A - BG2X_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400002C - BG2Y_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400002E - BG2Y_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000030 - BG3PA");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000032 - BG3PB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000034 - BG3PC");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000036 - BG3PD");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000038 - BG3X_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400003A - BG3X_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400003C - BG3Y_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400003E - BG3Y_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000040 - WIN0H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000042 - WIN1H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000044 - WIN0V");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000046 - WIN1V");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000048 - WININ");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400004A - WINOUT");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400004C - MOSAIC");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000050 - BLDCNT");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000052 - BLDALPHA");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000054 - BLDY");

			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000064 - DISPCAPCNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000066 - DISPCAPCNT_H");

			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000068 - RAMFIFO_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400006A - RAMFIFO_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400006C - BRIGHTNESS");

			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000B0 - DMA0SAD_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000B2 - DMA0SAD_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000B4 - DMA0DAD_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000B6 - DMA0DAD_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000B8 - DMA0CNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000BA - DMA0CNT_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000BC - DMA1SAD_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000BE - DMA1SAD_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000C0 - DMA1DAD_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000C2 - DMA1DAD_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000C4 - DMA1CNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000C6 - DMA1CNT_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000C8 - DMA2SAD_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000CA - DMA2SAD_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000CC - DMA2DAD_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000CE - DMA2DAD_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000D0 - DMA2CNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000D2 - DMA2CNT_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000D4 - DMA3SAD_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000D6 - DMA3SAD_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000D8 - DMA3DAD_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000DA - DMA3DAD_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000DC - DMA3CNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x040000DE - DMA3CNT_H");

			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000100 - TM0CNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000102 - TM0CNT_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000104 - TM1CNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000106 - TM1CNT_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000108 - TM2CNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400010A - TM2CNT_H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400010C - TM3CNT_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400010E - TM3CNT_H");

			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000208 - IME");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000210 - IE_L");

			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000240 - VRAMCNT_AB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000242 - VRAMCNT_CD");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000244 - VRAMCNT_EF");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000246 - VRAMCNT_G_WRAM");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000248 - VRAMCNT_HI");

			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04000304 - POWERCNT");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04001000 - DISPCNT_SUB_L");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04001002 - DISPCNT_SUB_H");

			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04001008 - BG0CNT_SUB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400100A - BG1CNT_SUB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400100C - BG2CNT_SUB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400100E - BG3CNT_SUB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04001050 - BLDCNT_SUB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04001052 - BLDALPHA_SUB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x04001054 - BLDY_SUB");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x0400106C - BRIGHTNESS_SUB");
			SendMessage(hCmb,CB_SETCURSEL,ioRegSel,0);

			if (romLoaded)
				regVal = mmu_read_word(ioreg_address[ioRegSel]);
			else
				regVal = 0;
			hCtl = GetDlgItem(hdlg,IDC_STATIC_V);
			wsprintf(szBuffer,"0x%04X",regVal&0xFFFF);
			SetWindowText(hCtl,szBuffer);
			for (i=0; i<16; i++)
			{
				hCtl = GetDlgItem(hdlg,IDC_CHECK1+i);
				SendMessage(hCtl,BM_SETCHECK,(regVal&1),0);
				SetWindowText(hCtl,ioreg_descr[ioRegSel][i]);
				regVal >>= 1;
			}

			hCtl = GetDlgItem(hdlg,IDC_CHECK17);
			EnableWindow(hCtl,FALSE);

			return TRUE;


		case WM_SIZE:
			return 0;


		case WM_PAINT:
			BeginPaint(hdlg,&ps);

			MoveToEx(iodc, 8, 80, NULL);
			LineTo(iodc, 328,80);

			MoveToEx(iodc, 8, 408, NULL);
			LineTo(iodc, 328,408);

			EndPaint(hdlg,&ps);
			break;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_COMBO3:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO3);
						ioRegSel = SendMessage(hCmb,CB_GETCURSEL,0,0);
						if (romLoaded)
							regVal = mmu_read_word(ioreg_address[ioRegSel]);
						else
							regVal = 0;
						hCtl = GetDlgItem(hdlg,IDC_STATIC_V);
						wsprintf(szBuffer,"0x%04X",regVal&0xFFFF);
						SetWindowText(hCtl,szBuffer);
						for (i=0; i<16; i++)
						{
							hCtl = GetDlgItem(hdlg,IDC_CHECK1+i);
							SendMessage(hCtl,BM_SETCHECK,(regVal&1),0);
							SetWindowText(hCtl,ioreg_descr[ioRegSel][i]);
							regVal >>= 1;
						}
						InvalidateRect(hdlg,NULL,TRUE);
					}
					return 0;

				case IDOK:
					ReleaseDC(hdlg,iodc);
					EndDialog(hdlg, 0);
					windows[7].active = false;
					return TRUE;

				case IDCANCEL:
				case IDCLOSE:
					ReleaseDC(hdlg,iodc);
					EndDialog(hdlg, 1);
					windows[7].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}


int bankOffset[] = {0,0x20000,0x40000,0x60000,0x80000,
0x90000,0x94000,0x98000,0xA0000};

int bankTiles[] = {4096,4096,4096,4096,
2048,512,512,1024,512};


// Tile viewer callback
BOOL CALLBACK DlgProc12(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i,j,k,l;
	HWND hCmb,hCtl,hSize2;
	HWND hScroll;
	unsigned short int *paletteData;
	unsigned char *tileSrc,*vramPtr;
	static int twTileNum = 0, twTileBlock=0, twTileOffset=0, tvTileBank=0;
	static int tvMemSel = 1,tvMaxTile=255;
	static int palType = 1, pal16PalPal = 0, pal16PalNum=0,
			   pal256Pal = 0, palExtPalBank=0, palExtPalSet=0,palExtPalNum = 0;

   switch(msg)
   {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			twdc = GetDC(hdlg);

			hCmb = GetDlgItem(hdlg,IDC_COMBO1);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"1");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"2");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"3");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"4");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"5");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"6");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"7");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"8");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"9");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"10");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"11");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"12");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"13");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"14");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"15");
			SendMessage(hCmb,CB_SETCURSEL,pal16PalNum,0);

			hCmb = GetDlgItem(hdlg,IDC_COMBO2);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Bank E");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Bank F");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Bank G");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Bank H");
			SendMessage(hCmb,CB_SETCURSEL,palExtPalBank,0);

			hCmb = GetDlgItem(hdlg,IDC_COMBO3);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Set 0");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Set 1");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Set 2");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Set 3");
			SendMessage(hCmb,CB_SETCURSEL,palExtPalSet,0);

			hCmb = GetDlgItem(hdlg,IDC_COMBO4);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"1");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"2");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"3");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"4");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"5");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"6");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"7");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"8");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"9");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"10");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"11");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"12");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"13");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"14");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"15");
			SendMessage(hCmb,CB_SETCURSEL,twTileBlock,0);
			EnableWindow(hCmb,(tvMemSel!=0));

			hCmb = GetDlgItem(hdlg,IDC_COMBO5);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x00000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x10000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x20000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x30000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x40000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x50000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x60000");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"0x70000");
			SendMessage(hCmb,CB_SETCURSEL,twTileOffset,0);
			EnableWindow(hCmb,(tvMemSel!=0));

			hCmb = GetDlgItem(hdlg,IDC_COMBO6);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 0");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 1");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 2");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 3");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 4");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 5");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 6");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 7");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 8");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 9");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 10");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 11");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 12");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 13");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 14");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Palette 15");
			SendMessage(hCmb,CB_SETCURSEL,palExtPalNum,0);

			hCmb = GetDlgItem(hdlg,IDC_COMBO7);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Main BG");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Main OBJ");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Sub BG");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Sub OBJ");
			SendMessage(hCmb,CB_SETCURSEL,pal256Pal,0);

			hCmb = GetDlgItem(hdlg,IDC_COMBO8);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Main BG");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Main OBJ");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Sub BG");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Sub OBJ");
			SendMessage(hCmb,CB_SETCURSEL,pal16PalPal,0);

			hCmb = GetDlgItem(hdlg,IDC_COMBO9);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"A");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"B");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"C");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"D");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"E");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"F");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"G");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"H");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"I");
			SendMessage(hCmb,CB_SETCURSEL,tvTileBank,0);
			EnableWindow(hCmb,(tvMemSel==0));

			hCtl = GetDlgItem(hdlg,IDC_RADIO1+palType);
			SendMessage(hCtl,BM_SETCHECK,1,0);

			hCtl = GetDlgItem(hdlg,((tvMemSel==0)?IDC_RADIO3:IDC_RADIO10));
			SendMessage(hCtl,BM_SETCHECK,1,0);

			/*hCtl = GetDlgItem(hdlg,IDC_SLIDER1);
			SendMessage(hCtl,TBM_SETRANGE,FALSE,MAKELONG(0,255));
			SendMessage(hCtl,TBM_SETPOS,TRUE,twTileNum);*/
			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
			ZeroMemory(&si4, sizeof(si4));
			si4.cbSize = sizeof(si);
			si4.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
			si4.nMin   = 0;
			si4.nMax   = tvMaxTile;
			si4.nPage  = 1;
			si4.nPos   = twTileNum;
			SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);

			hCtl = GetDlgItem(hdlg,IDC_STATIC_TILENUM);
			wsprintf(szBuffer,"%d",twTileNum);
			SetWindowText(hCtl,szBuffer);

			tile.data = (char*)&tileData[0];
			memset(&tile.bih,0,sizeof(BITMAPINFOHEADER));
 			tile.bih.biSize = sizeof(BITMAPINFOHEADER);
 			tile.bih.biWidth = 8;
 			tile.bih.biHeight = -8;
 			tile.bih.biPlanes = 1;
 			tile.bih.biBitCount = 16;
  			tile.bih.biCompression = BI_BITFIELDS;
			*((int*)&tile.colors[0]) = 0x001F;	// 00000000 000rrrrr
			*((int*)&tile.colors[1]) = 0x03E0;	// 000000gg ggg00000
			*((int*)&tile.colors[2]) = 0x7C00;	// 0bbbbb00 00000000

			vramPtr = (unsigned char*)gpu_get(GPU_MEMORY);

			return TRUE;


		case WM_HSCROLL:
			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
			if ((HWND)lParam != hScroll) return 0;

			twTileNum = GetScrollPos(hScroll, SB_CTL);
			switch (LOWORD(wParam))
			{
				case SB_TOP:
						twTileNum = 0;
						break;

				case SB_LINEUP:
						if (twTileNum > 0)
								twTileNum--;
						break;
				case SB_PAGEUP:
						if (twTileNum > 1)
								twTileNum -= 2;;
						break;

				case SB_THUMBPOSITION:
						twTileNum = HIWORD(wParam);
						break;

				case SB_THUMBTRACK:
						twTileNum = HIWORD(wParam);
						break;

				case SB_LINEDOWN:
						if (twTileNum < tvMaxTile)
								twTileNum++;
						break;
				case SB_PAGEDOWN:
						if (twTileNum < tvMaxTile-1)
								twTileNum += 2;
						break;

				case SB_BOTTOM:
						twTileNum = tvMaxTile;
						break;
			}
			hCtl = GetDlgItem(hdlg,IDC_STATIC_TILENUM);
			wsprintf(szBuffer,"%d",twTileNum);
			SetWindowText(hCtl,szBuffer);
			SetScrollPos(hScroll, SB_CTL, twTileNum, TRUE);
			rect2.top = 8;
			rect2.left = 12;
			rect2.right = rect2.bottom = 64;
			InvalidateRect(hdlg,&rect2,TRUE);
			return 0;


		case WM_SIZE:
			return 0;


		case WM_PAINT:
			BeginPaint(hdlg,&ps);

			/*MoveToEx(twdc, 8, 80, NULL);
			LineTo(twdc, 328,80);

			MoveToEx(iodc, 8, 408, NULL);
			LineTo(iodc, 328,408);*/
			if (romLoaded)
			{
				switch (palType)
				{
					case 0:
						paletteData = (unsigned short int*)(pageTable[0x50] + (pal16PalPal<<9) + (pal16PalNum<<5));
						if (tvMemSel==0) 
							tileSrc = (unsigned char*)(pageTable[0x60] + bankOffset[tvTileBank] + (twTileNum<<5));
						else
							tileSrc = (unsigned char *)(pageTable[0x60] + (twTileOffset<<16) + (twTileBlock<<14) + (twTileNum<<5));
						for (i=0; i<32; i++)
						{
							tileData[i+i] = paletteData[tileSrc[i]&0xF];
							tileData[i+i+1] = paletteData[(tileSrc[i]>>4)&0xF];
						}
						break;
					case 1:
						paletteData = (unsigned short int*)(pageTable[0x50] + (pal256Pal<<9));
						if (tvMemSel==0) 
							tileSrc = (unsigned char*)(pageTable[0x60] + bankOffset[tvTileBank] + (twTileNum<<6));
						else
							tileSrc = (unsigned char *)(pageTable[0x60] + (twTileOffset<<16) + (twTileBlock<<14) + (twTileNum<<6));
						for (i=0; i<64; i++)
						{
							tileData[i] = paletteData[tileSrc[i]];
						}
						break;
					case 2:
						paletteData = (unsigned short int*)(pageTable[0x60] + (lcdc_banks[palExtPalBank]&0xFFFFF) + (palExtPalSet<<13) + (palExtPalNum<<9));
						if (tvMemSel==0) 
							tileSrc = (unsigned char*)(pageTable[0x60] + bankOffset[tvTileBank] + (twTileNum<<6));
						else
							tileSrc = (unsigned char *)(pageTable[0x60] + (twTileOffset<<16) + (twTileBlock<<14) + (twTileNum<<6));
						for (i=0; i<64; i++)
						{
							tileData[i] = paletteData[tileSrc[i]];
						}
						break;
				}
				StretchDIBits(twdc,12,8,64,64,0,0,8,8,
							  tile.data,(BITMAPINFO*)&tile.bih,DIB_RGB_COLORS,SRCCOPY);
			}

			EndPaint(hdlg,&ps);
			break;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_COMBO1:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO1);
						pal16PalNum = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO2:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO2);
						palExtPalBank = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO3:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO3);
						palExtPalSet = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO4:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO4);
						twTileBlock = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO5:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO5);
						twTileOffset = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO6:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO6);
						palExtPalNum = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO7:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO7);
						pal256Pal = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO8:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO8);
						pal16PalPal = SendMessage(hCmb,CB_GETCURSEL,0,0);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;
				case IDC_COMBO9:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO9);
						tvTileBank = SendMessage(hCmb,CB_GETCURSEL,0,0);
						if (tvMemSel==0) {
							if (twTileNum >= bankTiles[tvTileBank])
								twTileNum = (twTileNum*tvMaxTile)/bankTiles[tvTileBank];
							tvMaxTile = bankTiles[tvTileBank]-1;
						} else
							tvMaxTile = 511;
						if ((LOWORD(wParam)==IDC_RADIO1)&&(palType!=0))
						{
							hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
							si4.nMax   = tvMaxTile;
							si4.nPos   = twTileNum;
							SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
						}
						if ((LOWORD(wParam)!=IDC_RADIO1)&&(palType==0))
						{
							hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
							twTileNum >>= 1;
							tvMaxTile >>= 1;
							si4.nMax   = tvMaxTile;
							si4.nPos   = twTileNum;
							SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
							hCtl = GetDlgItem(hdlg,IDC_STATIC_TILENUM);
							wsprintf(szBuffer,"%d",twTileNum);
							SetWindowText(hCtl,szBuffer);
						}
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;

				case IDC_RADIO3:
				case IDC_RADIO10:
					if (HIWORD(wParam)==BN_CLICKED)
					{
						tvMemSel = (LOWORD(wParam)==IDC_RADIO3)?0:1;
						hCmb = GetDlgItem(hdlg,IDC_COMBO4);
						EnableWindow(hCmb,tvMemSel);
						hCmb = GetDlgItem(hdlg,IDC_COMBO5);
						EnableWindow(hCmb,tvMemSel);
						hCmb = GetDlgItem(hdlg,IDC_COMBO9);
						EnableWindow(hCmb,1-tvMemSel);

						if (tvMemSel==0) {
							if (twTileNum >= bankTiles[tvTileBank])
								twTileNum = (twTileNum*tvMaxTile)/bankTiles[tvTileBank];
							tvMaxTile = bankTiles[tvTileBank]-1;
						} else
							tvMaxTile = 511;
						if ((LOWORD(wParam)==IDC_RADIO1)&&(palType!=0))
						{
							hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
							si4.nMax   = tvMaxTile;
							si4.nPos   = twTileNum;
							SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
						}
						if ((LOWORD(wParam)!=IDC_RADIO1)&&(palType==0))
						{
							hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
							twTileNum >>= 1;
							tvMaxTile >>= 1;
							si4.nMax   = tvMaxTile;
							si4.nPos   = twTileNum;
							SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
							hCtl = GetDlgItem(hdlg,IDC_STATIC_TILENUM);
							wsprintf(szBuffer,"%d",twTileNum);
							SetWindowText(hCtl,szBuffer);
						}
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;

				case IDC_RADIO1:
				case IDC_RADIO2:
				case IDC_RADIO_D3D:
					if (HIWORD(wParam)==BN_CLICKED)
					{
						if (tvMemSel==0) {
							if (twTileNum >= bankTiles[tvTileBank])
								twTileNum = (twTileNum*tvMaxTile)/bankTiles[tvTileBank];
							tvMaxTile = bankTiles[tvTileBank]-1;
						} else
							tvMaxTile = 511;
						if ((LOWORD(wParam)==IDC_RADIO1)&&(palType!=0))
						{
							hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
							si4.nMax   = tvMaxTile;
							si4.nPos   = twTileNum;
							SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
						}
						if ((LOWORD(wParam)!=IDC_RADIO1)&&(palType==0))
						{
							hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
							twTileNum >>= 1;
							tvMaxTile >>= 1;
							si4.nMax   = tvMaxTile;
							si4.nPos   = twTileNum;
							SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
							hCtl = GetDlgItem(hdlg,IDC_STATIC_TILENUM);
							wsprintf(szBuffer,"%d",twTileNum);
							SetWindowText(hCtl,szBuffer);
						}
						palType = LOWORD(wParam) - IDC_RADIO1;
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;

				case IDOK:
					ReleaseDC(hdlg,twdc);
					EndDialog(hdlg, 0);
					windows[8].active = false;
					return TRUE;

				case IDCANCEL:
				case IDCLOSE:
					ReleaseDC(hdlg,twdc);
					EndDialog(hdlg, 1);
					windows[8].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }


	return FALSE;
}



// Breakpoint viewer callback
BOOL CALLBACK DlgProc13(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i,j,k,l,factor;
	unsigned int bkptAddr;
	HWND hCmb,hCtl,hSize2;
	HWND hScroll;

   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			hCmb = GetDlgItem(hdlg,IDC_COMBO1);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM9 execute at");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM9 read from");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM9 write to");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM9 read byte from");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM9 read hword from");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM9 read word from");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM9 write byte to");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM9 write hword to");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM9 write word to");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM7 execute at");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM7 read byte from");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM7 read hword from");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"ARM7 read word from");
			SendMessage(hCmb,CB_SETCURSEL,0,0);
			EnableWindow(hCmb,FALSE);

			return TRUE;


		case WM_HSCROLL:
			/*hScroll = GetDlgItem(hdlg,IDC_SLIDER1);
			if ((HWND)lParam == hScroll)
			{
				twTileNum = SendMessage(hScroll,TBM_GETPOS,0,0);
				hCtl = GetDlgItem(hdlg,IDC_STATIC_TILENUM);
				wsprintf(szBuffer,"%d",twTileNum);
				SetWindowText(hCtl,szBuffer);
			}*/
			return 0;


		case WM_SIZE:
			return 0;


		case WM_PAINT:
			BeginPaint(hdlg,&ps);

			/*MoveToEx(twdc, 8, 80, NULL);
			LineTo(twdc, 328,80);

			MoveToEx(iodc, 8, 408, NULL);
			LineTo(iodc, 328,408);*/

			EndPaint(hdlg,&ps);
			break;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_COMBO3:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						//hCmb = GetDlgItem(hdlg,IDC_COMBO3);
						//ioRegSel = SendMessage(hCmb,CB_GETCURSEL,0,0);
					}
					return 0;

				case IDC_BUTTON5:
					hCtl = GetDlgItem(hdlg,IDC_EDIT1);
					GetWindowText(hCtl,szBuffer,10);
					factor = 10; // decimal
					j = strlen(szBuffer);
					if (j==0)
					{
						MessageBox(NULL,"No address entered","Error",MB_ICONINFORMATION);
						return 0;
					}
					if (j>=3)
						if (szBuffer[1]=='x')
							factor = 16; // hexadecimal
					k = 1;
					bkptAddr = 0;
					if (factor == 10)
						for (; j>0; j--)
						{
							if ((szBuffer[j-1]>='0')&&(szBuffer[j-1]<='9'))
								bkptAddr += (szBuffer[j-1]-'0')*k;
							else
							{
								MessageBox(NULL,"Not a valid address","Error",MB_ICONINFORMATION);
								return 0;
							}
							k *= 10;
						}
					else
						for (; j>2; j--)
						{
							if ((szBuffer[j-1]>='0')&&(szBuffer[j-1]<='9'))
								bkptAddr += (szBuffer[j-1]-'0')*k;
							else if ((szBuffer[j-1]>='a')&&(szBuffer[j-1]<='f'))
								bkptAddr += (szBuffer[j-1]+10-'a')*k;
							else if ((szBuffer[j-1]>='A')&&(szBuffer[j-1]<='F'))
								bkptAddr += (szBuffer[j-1]+10-'A')*k;
							else
							{
								MessageBox(NULL,"Not a valid address","Error",MB_ICONINFORMATION);
								return 0;
							}
							k *= 16;
						}

					hCtl = GetDlgItem(hdlg,IDC_LIST1);
					wsprintf(szBuffer,"ARM9 EXC -- 0x%08X",bkptAddr);
					SendMessage(hCtl,LB_ADDSTRING,0,(LPARAM)szBuffer);
					return 0;


				case IDOK:
					//ReleaseDC(hdlg,twdc);
					EndDialog(hdlg, 0);
					windows[9].active = false;
					return TRUE;

				case IDCANCEL:
				case IDCLOSE:
					//ReleaseDC(hdlg,twdc);
					EndDialog(hdlg, 1);
					windows[9].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}



// Video output callback
BOOL CALLBACK DlgProc14(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i; //,j,k;
	//HWND hCmb,hCtl,hSize2;

   switch(msg)
   {
		case WM_KEYDOWN:
			switch (wParam)
			{
				case VK_F5:
					if (romLoaded)
						run = true;
					break;
				case VK_F6:
					if (romLoaded)
						run = false;
					break;
				case VK_F7:
					if (romLoaded)
						reset_machine(false);
					break;
			}
			return 0;

		case WM_MOUSEMOVE:
			touch.x = touch.y = touch.z = 0;
			if (GET_Y_LPARAM(lParam)>=192)
			{
				if (wParam & MK_LBUTTON)
				{
					touch.x = GET_X_LPARAM(lParam); //+13;
					touch.y = GET_Y_LPARAM(lParam)+16-192;
					touch.z = -1;
					if (touch.x<0) touch.x = 0; if (touch.x>255) touch.x = 255;
				}
			}
			return 0;
		case WM_LBUTTONDOWN:
			if (GET_Y_LPARAM(lParam)>=192)
			{
				touch.x = GET_X_LPARAM(lParam); //+13;
				touch.y = GET_Y_LPARAM(lParam)+16-192;
				touch.z = -1;
				if (touch.x<0) touch.x = 0; if (touch.x>255) touch.x = 255;
			}
				wsprintf(szBuffer,"x = %d, y = %d | ipc_x = %d, ipc_y = %d\n",
					touch.x,touch.y,touch.x*14,(touch.y*8917)>>9);
				WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(LPDWORD)&i,NULL);
			return 0;

		case WM_LBUTTONUP:
			touch.x = 0;
			touch.y = 0;
			touch.z = 0;
			return 0;

		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);
			//force_window_size(hdlg,rect.right+24,rect.top,256,384);
			//UpdateWindow(hdlg);
			return TRUE;

		case WM_SIZE:
			return 0;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDCLOSE:
					EndDialog(hdlg, 1);
					windows[2].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}



BOOL CALLBACK DlgProc15(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i; //,j,k,l;
	HWND hCmb,hCtl;

   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			hCtl = GetDlgItem(hdlg,IDC_EDIT1);
			wsprintf(szBuffer,"0x%08x",dlg15EditVal);
			SetWindowText(hCtl,szBuffer);
			return TRUE;


		case WM_SIZE:
			return 0;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{

				case IDOK:
					hCtl = GetDlgItem(hdlg,IDC_EDIT1);

					GetWindowText(hCtl,szBuffer3,12);
					if (strlen(szBuffer3))
					{
						if (szBuffer3[0] != '0')
						{
							strcpy(szBuffer,"0x");
							strcat(szBuffer,szBuffer3);
						} else
						{
							strcpy(szBuffer,szBuffer3);
						}
						dlg15EditVal = strtoul(szBuffer,NULL,0);
					}
					EndDialog(hdlg, 0);
					windows[10].active = false;
					return TRUE;

				case IDCANCEL:
				case IDCLOSE:
					EndDialog(hdlg, 1);
					windows[10].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}




// AVI recording setup dialog
BOOL CALLBACK DlgProc16(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i,j,k,l;
	HWND hCmb,hCtl;

   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			hCtl = GetDlgItem(hdlg,IDC_CHECK1);
			SendMessage(hCtl,BM_SETCHECK,(recordMain)?BST_CHECKED:BST_UNCHECKED,0);
			hCtl = GetDlgItem(hdlg,IDC_CHECK3);
			SendMessage(hCtl,BM_SETCHECK,(recordSub)?BST_CHECKED:BST_UNCHECKED,0);

			hCtl = GetDlgItem(hdlg,IDC_EDIT1);
			wsprintf(szBuffer,"%d",aviRate);
			SetWindowText(hCtl,szBuffer);

			hCtl = GetDlgItem(hdlg,IDC_STATIC_FN);
			SetWindowText(hCtl,szAviFn);

			hCtl = GetDlgItem(hdlg,IDC_EDIT2);
			SetWindowText(hCtl,"0");
			EnableWindow(hCtl,FALSE);

			hCmb = GetDlgItem(hdlg,IDC_COMBO1);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"RGB24");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"UYVY");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"YV12");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"NV12");
			SendMessage(hCmb,CB_SETCURSEL,0,0);

			return TRUE;


		case WM_SIZE:
			return 0;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{

				case IDC_CHECK1:
					hCtl = GetDlgItem(hdlg,IDC_CHECK1);
					recordMain = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 1 : 0;
					return 0;

				case IDC_CHECK3:
					hCtl = GetDlgItem(hdlg,IDC_CHECK3);
					recordSub = (SendMessage(hCtl,BM_GETCHECK,0,0)==BST_CHECKED) ? 1 : 0;
					return 0;

				case IDOK:
					hCtl = GetDlgItem(hdlg,IDC_EDIT1);
					GetWindowText(hCtl,szBuffer3,12);
					if (strlen(szBuffer3))
					{
						if (szBuffer3[0] != '0')
						{
							//strcpy(szBuffer,"0x");
							//strcat(szBuffer,szBuffer3);
							strcpy(szBuffer,szBuffer3);
						} else
						{
							strcpy(szBuffer,szBuffer3);
						}
						aviRate = strtoul(szBuffer,NULL,0);
					}
					if ((aviRate>0)&&(aviRate<=60))
					{
						EndDialog(hdlg, 0);
						windows[11].active = false;
					} else
					{
						aviRate = 30;
						MessageBox(NULL,"Enter a value from 1 to 60","Bad fps",MB_ICONERROR|MB_OK);
					}
					return TRUE;

				case IDC_BUTTON2:
					get_savefilename(szAviFn,"Save as..","AVI files (*.avi)\0*.avi\0");
					hCtl = GetDlgItem(hdlg,IDC_STATIC_FN);
					SetWindowText(hCtl,szAviFn);
					InvalidateRect(hdlg,NULL,TRUE);
					avigen.SetFileName(_T(szAviFn));
					return TRUE;
					break;

				case IDC_BUTTON_COMPRESS:
					if (!aviStreamCreated)
					{
						avi_setup();
						if (avigen.CreateStream() != AVIERR_OK)
						{
							MessageBox(NULL,"Failed to create stream","AVI recorder",MB_ICONERROR|MB_OK);
							return FALSE;
						}
						aviStreamCreated = true;
					}
					aviCodecSelected = (avigen.CodecSelect() == AVIERR_OK);
					return TRUE;

				case IDCANCEL:
				case IDCLOSE:
					EndDialog(hdlg, 1);
					windows[11].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}



int oamTNum=-1,oamPosX=-1,oamPosY=-1,oamSizeX=-1,oamSizeY=-1,oamColors=-1,oamMode=-1,
    oamMapping=-1,oamRS=-1,oamDouble=-1,oamPrio=-1,oamVisible=-1,
	oamFlip=-1,oamPal=-1;
const int objWidths[16] = {
	8,16,32,64, 16,32,32,64, 8,8,16,32, 0,0,0,0};
const int objHeights[16] = {
	8,16,32,64, 8,8,16,32, 16,32,32,64, 0,0,0,0};
const char objModes[4][8] = {
	"Normal","Transp.","Window","Bitmap"};
const char objFlip[4][3] = {
	"--","H ","V ","HV"};
const char objYesNo[2][4] = {
	"No","Yes"};
void UpdateOAMProperties(HWND hdlg,int core,int num)
{
	HWND hCtl;

	unsigned short *oamData;
	
	if (romLoaded) 
	{
		oamData = (unsigned short*)(pageTable[0x70] + (core<<10) + (num<<3));
		oamTNum = oamData[2]&0x3FF;
		oamPosX = oamData[1]&0x1FF;
		oamPosY = oamData[0]&0xFF;
		oamMode = oamData[0]&0xC00;
		oamColors = (oamMode!=0xC00)?(oamData[0]&0x2000):0x5800;
		oamRS = ((oamData[0]&0x100)==0)?-1:(oamData[1]&0x3E00);
		oamDouble = (oamRS==-1)?-1:(oamData[0]&0x200);
		oamFlip = (oamRS==-1)?(oamData[1]&0x3000):-1;
		oamPrio = oamData[2]&0xC00;
		oamSizeX = ((oamData[1]>>14)&3);
		oamSizeX |=((oamData[0]>>12)&0xC);
		oamSizeY = objHeights[oamSizeX];
		oamSizeX = objWidths[oamSizeX];
		oamVisible = (oamRS==-1)?(oamData[0]&0x200):-1;
		oamPal = (oamColors!=0x5800)?(oamData[2]&0xF000):-1;
	} else
	{
		oamTNum = oamPosX = oamSizeX = oamColors = oamMode = -1;
		oamMapping = oamRS = oamDouble = oamPrio = oamVisible = oamFlip = oamPal = -1;
	}

	hCtl = GetDlgItem(hdlg,IDC_OTNUM);
	if (oamTNum != -1)
		wsprintf(szBuffer,"%d",oamTNum);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_OPOS);
	if (oamPosX != -1)
		wsprintf(szBuffer,"%d,%d",oamPosX,oamPosY);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_OSIZE);
	if (oamSizeX != -1)
		wsprintf(szBuffer,"%d*%d",oamSizeX,oamSizeY);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_ORS);
	if (oamRS != -1)
		wsprintf(szBuffer,"Yes, %d",oamRS>>9);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_OPRIO);
	if (oamPrio != -1)
		wsprintf(szBuffer,"%d",oamPrio>>10);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_OCOLORS);
	if (oamColors != -1)
		wsprintf(szBuffer,"%d",(1<<(4+(oamColors>>11))));
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_OMODE);
	if (oamMode != -1)
		wsprintf(szBuffer,"%s",objModes[oamMode>>10]);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_OFLIP);
	if (oamFlip != -1)
		wsprintf(szBuffer,"%s",objFlip[oamFlip>>12]);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_OVISIBLE);
	if (oamVisible != -1)
		wsprintf(szBuffer,"%s",objYesNo[1-(oamVisible>>9)]);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_ODOUBLE);
	if (oamDouble != -1)
		wsprintf(szBuffer,"%s",objYesNo[(oamDouble>>9)]);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_OPAL);
	if (oamPal != -1)
		wsprintf(szBuffer,"%d",oamPal>>12);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);
}


const int ceil_log2[17] = {
	1,1,2,2,3,3,3,3,4,4,4,4,4,4,4,4,5};

// Nasty code coming up..
void RenderOBJ(unsigned char *dest,int core,int num,bool applyFx)
{
	unsigned short *palData,*dest2,c;
	short int *oamData;
	unsigned char *src,*patternTbl,*io_base;
	DWORD dwDummy;
	int x,y,u,v,width,realWidth,realHeight,height,pa,pb,pc,pd,x2,y2,k,x3,y3;
	int cmTileShift,tileShift,hTileMask,vTileMask,hScrShift,vScrShift,
		hofs,vofs,offset,objTile;

	if (romLoaded)
	{
		io_base = (unsigned char*)(pageTable[0x40] + (core<<12));
		oamData = (short*)(pageTable[0x70] + (core<<10) + (num<<3));
		palData = (unsigned short*)(pageTable[0x50] + (core<<10) + 0x200);

		width = ((oamData[1]>>14)&3) | ((oamData[0]>>12)&0xC);
		height = objHeights[width];
		width = objWidths[width];

		patternTbl = (unsigned char*)gpu_get(GPU_MAIN_OBJ+core);
		if (patternTbl == (unsigned char*)-1) return;

		cmTileShift = 5;
		if (io_base[0]&0x10)
		{
			cmTileShift += (io_base[2]>>4)&3;
		}

		// 128x128 2D
		// Lots of magic numbers follow..
		tileShift = 3+0;
		hTileMask = 0x3F0;
		vTileMask = 0x00F;
		hScrShift = 7;
		vScrShift = 4;
		hofs = 0;
		vofs = 11;

		if ((io_base[0]&0x60)==0x20)
		{
			// 256x64 2D
			tileShift = 3+0;
			hTileMask = 0x3E0;
			vTileMask = 0x01F;
			hScrShift = 7;
			vScrShift = 4;
			hofs = 0;
			vofs = 12;
		} else if ((io_base[0]&0x60)==0x40)
		{
			tileShift = 3+0;
			hTileMask = 0x3FF;
			vTileMask = 0x000;
			hScrShift = 7 + ((io_base[2]>>6)&1);
			vScrShift = 0;
			hofs = 112;
			vofs = 7;
		}

	//wsprintf(szBuffer,"w=%d, h=%d, l2=%d\n",width,height,ceil_log2[width>>2]);
	//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
		realWidth = width;
		if ((oamDouble != -1) && applyFx) {
			width += width;
			height += height;
		}
		for (y=0; y<(height>>3); y++) {
			for (v=0; v<8; v++) {
				for (x=0; x<(width>>3); x++) {
					for (u=0; u<8; u++)
					{
						dest2 = (unsigned short*)dest;
						if ((oamData[0]&0xC00)!=0xC00)
						{
							hofs = 56;
							if (oamData[0]&0x2000)			// 256 colors
							{
								if ((oamData[0]&0x100)&&applyFx)	// R/S
								{
									pa = oamData[(oamRS>>5)+3-(num<<2)];
									pb = oamData[(oamRS>>5)+7-(num<<2)];
									pc = oamData[(oamRS>>5)+11-(num<<2)];
									pd = oamData[(oamRS>>5)+15-(num<<2)];

									x2 = ((x<<3)+u)-(width>>1);
									y2 = ((y<<3)+v)-(height>>1);
									k = ((width<<6) + (x2*pa + y2*pb))>>8;
									y2 = ((height<<6) + (x2*pc + y2*pd))>>8;
									x2 = k;
									if ((x2>=0)&&(y2>=0)&&(x2<(width>>1))&&(y2<(height>>1))) {
										x3 = x2>>3; y3 = y2>>3;
										if (io_base[0]&0x10)
											objTile = (y3<<(ceil_log2[realWidth>>2]-1));	// 1D
										else
											objTile = (y3<<5);	
										// 2D
										offset = (objTile<<5) + (x3<<6) + ((oamData[2]&0x3FF)<<cmTileShift) +
											     ((y2&7)<<3) + (x2&7);
										*dest2 = palData[patternTbl[offset]];
									} else {
										*dest2 = 0;
									}
								} else
								{
									if (io_base[0]&0x10)
										objTile = (y<<(ceil_log2[width>>2]-1));	// 1D
									else
										objTile = (y<<5);						// 2D

									offset = (objTile<<5) + (x<<6) + ((oamData[2]&0x3FF)<<cmTileShift) +
										     (v<<3) + u;
									*dest2 = palData[patternTbl[offset]];
								}
							} else							// 16 colors
							{
								if ((oamData[0]&0x100)&&applyFx)		// R/S
								{
									pa = oamData[(oamRS>>5)+3-(num<<2)];
									pb = oamData[(oamRS>>5)+7-(num<<2)];
									pc = oamData[(oamRS>>5)+11-(num<<2)];
									pd = oamData[(oamRS>>5)+15-(num<<2)];
									x2 = ((x<<3)+u)-(width>>1);
									y2 = ((y<<3)+v)-(height>>1);
									k = ((width<<6) + (x2*pa + y2*pb))>>8;
									y2 = ((height<<6) + (x2*pc + y2*pd))>>8;
									x2 = k;
									if ((x2>=0)&&(y2>=0)&&(x2<(width>>1))&&(y2<(height>>1))) {
										x3 = x2>>3; y3 = y2>>3;
										if (io_base[0]&0x10)
											objTile = (y3<<(ceil_log2[realWidth>>3]-1));	// 1D
										else
											objTile = (y3<<5);	
										// 2D
										offset = (objTile<<5) + (x3<<5) + ((oamData[2]&0x3FF)<<cmTileShift) +
											     ((y2&7)<<2) + ((x2&7)>>1);
										if (x2&1)
											*dest2 = palData[((oamData[2]>>12)<<4)+((patternTbl[offset])>>4)];
										else
											*dest2 = palData[((oamData[2]>>12)<<4)+((patternTbl[offset])&0xF)];
									} else {
										*dest2 = 0;
									}
								} else
								{
									if (io_base[0]&0x10)
										objTile = (y<<(ceil_log2[width>>3]-1));
									else
										objTile = (y<<5);
									offset = (objTile<<5) + (x<<5) + ((oamData[2]&0x3FF)<<cmTileShift) + (v<<2) + (u>>1);
									if (u&1)
										*dest2 = palData[((oamData[2]>>12)<<4)+((patternTbl[offset])>>4)];
									else
										*dest2 = palData[((oamData[2]>>12)<<4)+((patternTbl[offset])&0xF)];
								}
							}
						} else							// Bitmap OBJ
						{
							if ((oamData[0]&0x100)&&applyFx)		// R/S
							{
	//wsprintf(szBuffer,"oamRS>>5 = %d\n",oamRS>>5);
	//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
								pa = oamData[(oamRS>>5)+3-(num<<2)];
								pb = oamData[(oamRS>>5)+7-(num<<2)];
								pc = oamData[(oamRS>>5)+11-(num<<2)];
								pd = oamData[(oamRS>>5)+15-(num<<2)];
								x2 = ((x<<3)+u)-(width>>1);
								y2 = ((y<<3)+v)-(height>>1);
								k = ((width<<6) + (x2*pa + y2*pb))>>8;
								y2 = ((height<<6) + (x2*pc + y2*pd))>>8;
								x2 = k;
								//x2 = y2 = 0;
	//wsprintf(szBuffer,"x,y=%d,%d. x2,y2=%d,%d\n",(x<<3)+u,(y<<3)+v,x2,y2);
	//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
								if ((x2>=0)&&(y2>=0)&&(x2<(width>>1))&&(y2<(height>>1))) {
									objTile = (oamData[2]&0x3FF);
									offset = (objTile&hTileMask)<<hScrShift;
									offset += (objTile&vTileMask)<<vScrShift;
									offset += ((y2&7)<<(vofs-3));
									offset += ((y2>>3)<<vofs);
									offset += ((x2>>3)<<(tileShift+1)) + ((x2&7)<<1);
									c = *(unsigned short*)(patternTbl + offset);
									*dest2 = (c&0x8000)?(c&0x7FFF):0;
								} else {
									*dest2 = 0;
								}
								
							} else
							{
								objTile = (oamData[2]&0x3FF);
								offset = (objTile&hTileMask)<<hScrShift;
								offset += (objTile&vTileMask)<<vScrShift;
								offset += (v<<(vofs-3));
								offset += (y<<vofs);
								offset += (x<<(tileShift+1)) + u+u;
								c = *(unsigned short*)(patternTbl + offset);
								*dest2 = (c&0x8000)?(c&0x7FFF):0;
							}
						}
						dest += 2;
					}
				}
			}
		}
	}
}


// OAM viewer callback
BOOL CALLBACK DlgProc17(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i,j,k,l;
	HWND hCmb,hCtl,hScroll;
	static int oamNum = 0,oamCore=0;
	
   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);

			oamdc = GetDC(hdlg);

			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
			ZeroMemory(&si4, sizeof(si4));
			si4.cbSize = sizeof(si);
			si4.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
			si4.nMin   = 0;
			si4.nMax   = 127;
			si4.nPage  = 1;
			si4.nPos   = oamNum;
			SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);

			hCtl = GetDlgItem(hdlg,IDC_STATIC_TILENUM);
			wsprintf(szBuffer,"%d",oamNum);
			SetWindowText(hCtl,szBuffer);

			hCmb = GetDlgItem(hdlg,IDC_COMBO1);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Main");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Sub");
			SendMessage(hCmb,CB_SETCURSEL,oamCore,0);

			objPlain.data = (char*)&objPlainData[0];
			memset(&objPlain.bih,0,sizeof(BITMAPINFOHEADER));
 			objPlain.bih.biSize = sizeof(BITMAPINFOHEADER);
 			objPlain.bih.biWidth = 8;
 			objPlain.bih.biHeight = -8;
 			objPlain.bih.biPlanes = 1;
 			objPlain.bih.biBitCount = 16;
  			objPlain.bih.biCompression = BI_BITFIELDS;
			*((int*)&objPlain.colors[0]) = 0x001F;	// 00000000 000rrrrr
			*((int*)&objPlain.colors[1]) = 0x03E0;	// 000000gg ggg00000
			*((int*)&objPlain.colors[2]) = 0x7C00;	// 0bbbbb00 00000000

			objFinal.data = (char*)&objFinalData[0];
			memset(&objFinal.bih,0,sizeof(BITMAPINFOHEADER));
 			objFinal.bih.biSize = sizeof(BITMAPINFOHEADER);
 			objFinal.bih.biWidth = 8;
 			objFinal.bih.biHeight = -8;
 			objFinal.bih.biPlanes = 1;
 			objFinal.bih.biBitCount = 16;
  			objFinal.bih.biCompression = BI_BITFIELDS;
			*((int*)&objFinal.colors[0]) = 0x001F;	// 00000000 000rrrrr
			*((int*)&objFinal.colors[1]) = 0x03E0;	// 000000gg ggg00000
			*((int*)&objFinal.colors[2]) = 0x7C00;	// 0bbbbb00 0000000

			UpdateOAMProperties(hdlg,oamCore,oamNum);
			RenderOBJ((unsigned char*)objPlain.data,oamCore,oamNum,false);
			RenderOBJ((unsigned char*)objFinal.data,oamCore,oamNum,true);
			return TRUE;

		case WM_HSCROLL:
			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
			if ((HWND)lParam != hScroll) return 0;

			oamNum = GetScrollPos(hScroll, SB_CTL);
			switch (LOWORD(wParam))
			{
				case SB_TOP:
						oamNum = 0;
						break;

				case SB_LINEUP:
						if (oamNum > 0)
								oamNum--;
						break;
				case SB_PAGEUP:
						if (oamNum > 1)
								oamNum -= 2;;
						break;

				case SB_THUMBPOSITION:
						oamNum = HIWORD(wParam);
						break;

				case SB_THUMBTRACK:
						oamNum = HIWORD(wParam);
						break;

				case SB_LINEDOWN:
						if (oamNum < 127)
								oamNum++;
						break;
				case SB_PAGEDOWN:
						if (oamNum < 126)
								oamNum += 2;
						break;

				case SB_BOTTOM:
						oamNum = 127;
						break;
			}
			hCtl = GetDlgItem(hdlg,IDC_OAMNUM);
			wsprintf(szBuffer,"%d",oamNum);
			SetWindowText(hCtl,szBuffer);
			SetScrollPos(hScroll, SB_CTL, oamNum, TRUE);
			UpdateOAMProperties(hdlg,oamCore,oamNum);
			RenderOBJ((unsigned char*)objPlain.data,oamCore,oamNum,false);
			RenderOBJ((unsigned char*)objFinal.data,oamCore,oamNum,true);
			rect2.top = 100;
			rect2.left = 100;
			rect2.right = rect2.bottom = 64;
			InvalidateRect(hdlg,NULL,TRUE);
			return 0;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);

			if (romLoaded)
			{
				if (oamSizeX!=-1) {
					objPlain.bih.biWidth = oamSizeX;
 					objPlain.bih.biHeight = -oamSizeY;
					objFinal.bih.biWidth = oamSizeX;
 					objFinal.bih.biHeight = -oamSizeY;
					l = 1;
					if ((oamFlip&0x1000)&&(oamRS==-1))
						l = -1;
					if ((oamFlip&0x2000)&&(oamRS==-1))
						objFinal.bih.biHeight = oamSizeY;

					StretchDIBits(oamdc,154,72+20,oamSizeX,oamSizeY,0,0,oamSizeX,oamSizeY,
								  objPlain.data,(BITMAPINFO*)&objPlain.bih,DIB_RGB_COLORS,SRCCOPY);
					if (oamDouble==-1)
						StretchDIBits(oamdc,154+((l==-1)?oamSizeX:0),196+20,oamSizeX*l,oamSizeY,0,0,oamSizeX,oamSizeY,
								  objFinal.data,(BITMAPINFO*)&objFinal.bih,DIB_RGB_COLORS,SRCCOPY);
					else {
						objFinal.bih.biWidth *= 2;
						objFinal.bih.biHeight *= 2;
						StretchDIBits(oamdc,154+((l==-1)?oamSizeX*2:0),196+20,oamSizeX*2*l,oamSizeY*2,0,0,oamSizeX*2,oamSizeY*2,
								  objFinal.data,(BITMAPINFO*)&objFinal.bih,DIB_RGB_COLORS,SRCCOPY);
					}
				}
			}
			EndPaint(hdlg,&ps);
			break;

		case WM_SIZE:
			return 0;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{

				case IDC_COMBO1:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO1);
						oamCore = SendMessage(hCmb,CB_GETCURSEL,0,0);
						UpdateOAMProperties(hdlg,oamCore,oamNum);
						RenderOBJ((unsigned char*)objPlain.data,oamCore,oamNum,false);
						RenderOBJ((unsigned char*)objFinal.data,oamCore,oamNum,true);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;

				case IDC_BUTTON1:
					UpdateOAMProperties(hdlg,oamCore,oamNum);
					RenderOBJ((unsigned char*)objPlain.data,oamCore,oamNum,false);
					RenderOBJ((unsigned char*)objFinal.data,oamCore,oamNum,true);
					InvalidateRect(hdlg,NULL,FALSE);
					return 0;

				case IDCANCEL:
				case IDCLOSE:
					ReleaseDC(hdlg,oamdc);
					EndDialog(hdlg, 1);
					windows[13].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}



const int bgMemBase[2] = {0x000>>2,0x200>>2};

int bg0on=0,bg1on=0,bg2on=0,bg3on=0;
int bgSizeX,bgSizeY,bgCharAdr,bgScrAdr;
int bgMosaic,bgColors,bgPrio,bgPal;
int mapBg=0;
unsigned int scrBase,chrBase;
unsigned char *charBank,*screenBank;

void GetTextBGBank(int core,int bg) {
	int i;
	int cntReg,ofsReg,colMode;
	int chrBaseDec,scrBaseDec;
	unsigned char *io_base;

	io_base = (unsigned char*)(pageTable[0x40] + (core<<12));

	// Get the control register offset of this background
	cntReg = 0x08 + (bg<<1);
	ofsReg = 0x10 + (bg<<2);

	// Get the CHR base, SCR base and color mode
	chrBase = (io_base[cntReg] >> 2) & 0xF;
	scrBase = io_base[cntReg+1] & 0x1F;
	colMode = io_base[cntReg] & 0x80;

	charBank = NULL;
	screenBank = NULL;
	chrBaseDec = 0;
	scrBaseDec = 0;

	for (i=0; i<9; i++)
	{
		if (vramBank[i].type == MAIN_BG+core)
		{
			if ((chrBase >= vramBank[i].base-bgMemBase[core]) &&
				(chrBase < vramBank[i].base+vramBank[i].size-bgMemBase[core]))
			{
				charBank = (unsigned char*)pageTable[0x60] + bankOffset[i]; //vramBase[i];
			} else if (chrBase >= vramBank[i].base-bgMemBase[core])
			{
				chrBaseDec += vramBank[i].size;
			}

			if (((scrBase>>3) >= vramBank[i].base-bgMemBase[core]) &&
				((scrBase>>3) < vramBank[i].base+vramBank[i].size-bgMemBase[core]))
			{
				screenBank = (unsigned char*)pageTable[0x60] + bankOffset[i];
				if (charBank!=NULL) break;
			} else if ((scrBase>>3) >= vramBank[i].base-bgMemBase[core])
			{
				scrBaseDec += (vramBank[i].size<<3);
			}
		}
	}
	chrBase -= chrBaseDec;
	scrBase -= scrBaseDec;
}


void GetExtRsBGBank(int core,int bg) {
	int cntReg,colMode,bmpOffs;
	int i,chrBaseDec,scrBaseDec;
	unsigned char *io_base;
	unsigned short bgcnt;

	// Get the control register offset of this background
	cntReg = 8 + (bg<<1);
	io_base = (unsigned char*)(pageTable[0x40] + (core<<12));

	bgcnt = *(unsigned short*)(io_base + cntReg);

	// Get the CHR base, SCR base and color mode
	chrBase = (io_base[cntReg] >> 2) & 3;
	scrBase = io_base[cntReg+1] & 0x1F;
	colMode = io_base[cntReg] & 0x80;

	charBank = NULL;
	chrBaseDec = 0;
	screenBank = NULL;
	scrBaseDec = 0;

	if (colMode)
	{
		for (i=0; i<9; i++)
		{
			if (vramBank[i].type == MAIN_BG+core)
			{
				if (((scrBase) >= vramBank[i].base-bgMemBase[core]) &&
					((scrBase) < vramBank[i].base+vramBank[i].size-bgMemBase[core]))
				{
					charBank = (unsigned char*)pageTable[0x60] + bankOffset[i];
					break;
				} else if ((scrBase) >= vramBank[i].base-bgMemBase[core])
				{
					scrBaseDec += vramBank[i].size;
				}
			}
		}
	} else
	{
		for (i=0; i<9; i++)
		{
			if (vramBank[i].type == MAIN_BG+core)
			{
				if ((chrBase >= vramBank[i].base-bgMemBase[core]) &&
					(chrBase < vramBank[i].base+vramBank[i].size-bgMemBase[core]))
				{
					charBank = (unsigned char*)pageTable[0x60] + bankOffset[i];
				} else if (chrBase >= vramBank[i].base-bgMemBase[core])
				{
					chrBaseDec += vramBank[i].size;
				}

				if (((scrBase>>3) >= vramBank[i].base-bgMemBase[core]) &&
					((scrBase>>3) < vramBank[i].base+vramBank[i].size-bgMemBase[core]))
				{
					screenBank = (unsigned char*)pageTable[0x60] + bankOffset[i];
					if (charBank!=NULL) break;
				} else if ((scrBase>>3) >= vramBank[i].base-bgMemBase[core])
				{
					scrBaseDec += vramBank[i].size;
				}
			}
		}
	}

	chrBase -= chrBaseDec;
	scrBase -= scrBaseDec;
}



void RenderTileBG(unsigned short *dest,unsigned short *palData,int core,int bg,int xpos,int ypos) {
	int i,j,i2,j2,tilen,offset,tilePal;

	GetTextBGBank(core,bg);
	if ((screenBank==NULL)||(charBank==NULL)) return;

	if (bgColors==16) {
		for (i=0; i<192; i++) {
			for (j=0; j<256; j++) {
				i2 = i+ypos; j2=j+xpos;
				tilen = *(unsigned short*)(screenBank + (scrBase<<11) +
									       (((i2&0xff)>>3)*32*2) + ((i2&0x300)<<3)*(bgSizeX>>8) +
										   (((j2&0xff)>>3)*2) + ((j2&0x100)<<3));
				offset =  (chrBase<<14) + ((tilen&0x3FF)<<5) + ((i2&7)<<2) + ((j2&7)>>1);
				tilePal = (tilen>>12);
				if (j2&1)
					dest[(i<<8)+j] = palData[(tilePal<<4)+(*(unsigned char*)(charBank+offset)>>4)];
				else
					dest[(i<<8)+j] = palData[(tilePal<<4)+(*(unsigned char*)(charBank+offset)&0xF)];
			}
		}
	} else if (bgColors==256) {
		for (i=0; i<192; i++) {
			for (j=0; j<256; j++) {
				i2 = i+ypos; j2 = j+xpos;
				tilen = *(unsigned short*)(screenBank + (scrBase<<11) +
									       (((i2&0xff)>>3)*32*2) + ((i2&0x300)<<3)*(bgSizeX>>8) +
										   (((j2&0xff)>>3)*2) +((j2&0x100)<<3));
				offset =  (chrBase<<14) + ((tilen&0x3FF)<<6) + ((i2&7)<<3) + (j2&7);
				dest[(i<<8)+j] = palData[*(unsigned char*)(charBank+offset)];
			}
		}
	}
}




void RenderBG(HWND hdlg,unsigned short *dest,int core,int num,int xpos,int ypos)
{
	int i,j,tilen,offset;
	unsigned short *palData;
	unsigned char *io_base;
	
	memset(dest,0,256*192*2);

	if (romLoaded) {
		io_base = (unsigned char*)(pageTable[0x40] + (core<<12));
		palData = (unsigned short*)(pageTable[0x50] + (core<<10));

		if ((io_base[2]&3)==1) {
			switch (io_base[0]&7) {
				case 0:
					RenderTileBG(dest,palData,core,num,xpos,ypos);
					break;
				case 1:
				case 2:
					break;
				case 3:
					if (num<3) {
						RenderTileBG(dest,palData,core,num,xpos,ypos);
					} else {
						GetExtRsBGBank(core,num);
						if (charBank != NULL) {
							if (bgColors==256) {
								for (i=0; i<bgSizeY; i++) {
									for (j=0; j<bgSizeX; j++) {
										dest[(i<<8)+j] = 
											palData[*(unsigned char*)(charBank + 
																(scrBase<<14) +
																((i+ypos)*bgSizeX) +
																xpos+j)];
										if (j==255) break;
									}
									if (i==191) break;
								}
							} else if (bgColors==32768) {
								for (i=0; i<bgSizeY; i++) {
									for (j=0; j<bgSizeX; j++) {
										dest[(i<<8)+j] = 
											*(unsigned short*)(charBank + 
																(scrBase<<14) +
																((i+ypos)*bgSizeX*2) +
																xpos+xpos+j+j);
										if (j==255) break;
									}
									if (i==191) break;
								}
							}
						}
					}
					break;
				case 4:
					if ((num==0)||(num==1))
					{
						RenderTileBG(dest,palData,core,num,xpos,ypos);
					} else if (num==3) {
						GetExtRsBGBank(core,num);
						if (charBank != NULL) {
							if (bgColors==32768) {
								for (i=0; i<bgSizeY; i++) {
									for (j=0; j<bgSizeX; j++) {
										dest[(i<<8)+j] = 
											*(unsigned short*)(charBank + 
																(scrBase<<14) +
																((i+ypos)*bgSizeX*2) +
																xpos+xpos+j+j);
										if (j==255) break;
									}
									if (i==191) break;
								}
							}
						}
					}
					break;
				case 5:
					if ((num==2)||(num==3)) {
						GetExtRsBGBank(core,num);
						if (charBank != NULL) {
							if (bgColors==256) {
								for (i=0; i<bgSizeY; i++) {
									for (j=0; j<bgSizeX; j++) {
										dest[(i<<8)+j] = 
											palData[*(unsigned char*)(charBank + 
																(scrBase<<14) +
																((i+ypos)*bgSizeX) +
																xpos+j)];
										if (j==255) break;
									}
									if (i==191) break;
								}
							} else if (bgColors==32768) {
								for (i=0; i<bgSizeY; i++) {
									for (j=0; j<bgSizeX; j++) {
										dest[(i<<8)+j] = 
											*(unsigned short*)(charBank + 
																(scrBase<<14) +
																((i+ypos)*bgSizeX*2) +
																xpos+xpos+j+j);
										if (j==255) break;
									}
									if (i==191) break;
								}
							}
						}
					}
					break;
				case 6:
					if (num == 2) {
						if ((io_base[0x240]==0x81) && (io_base[0x241]==0x89)) {
							for (i=0; i<192; i++) {
								for (j=0; j<256; j++) {
									dest[(i<<8)+j] = palData[*(unsigned char*)(pageTable[0x60] + (i+ypos)*bgSizeX + xpos + j)];
								}
							}
						}
					}
					break;
			}
		}
	}
}


const int bmpBgSize[2][4]  = {{128,256,512,512},{128,256,256,512}};
const int textBgSize[2][4] = {{256,512,256,512},{256,256,512,512}};

// Redundancy-o-rama
void UpdateBGProperties(HWND hdlg,int core,int num) {
	HWND hCtl;
	unsigned char *io_base;
	unsigned short bgcnt;
	int i;

	bgSizeX = bgSizeY = bgColors = -1;
	bgCharAdr = bgScrAdr = bgMosaic = -1;

	if (romLoaded) {
		io_base = (unsigned char*)(pageTable[0x40] + (core<<12));
		bgcnt = io_base[8+num*2] + (io_base[9+num*2]<<8);
		bgPrio = bgcnt&3;

		switch (io_base[0]&7) {
			case 0:
				bg0on = bg1on = bg2on = bg3on = 1;
				bgColors = 1<<(4+((bgcnt>>5)&4));
				bgCharAdr = 0x4000 * ((bgcnt>>2)&0xF);
				bgScrAdr = 0x800 * ((bgcnt>>8)&0x1F);
				bgSizeX = textBgSize[0][bgcnt>>14];
				bgSizeY = textBgSize[1][bgcnt>>14];
				if (num==0) {
				} else if (num==1) {
				} else if (num==2) {
				} else if (num==3) {
				}
				break;
			case 1:
				bg0on = bg1on = bg2on = bg3on = 1;
				break;
			case 2:
				bg0on = bg1on = bg2on = bg3on = 1;
				break;
			case 3:
				bg0on = bg1on = bg2on = bg3on = 1;
				if (num==0) {
					bgColors = 1<<(4+((bgcnt>>5)&4));
					bgCharAdr = 0x4000 * ((bgcnt>>2)&0xF);
					bgScrAdr = 0x800 * ((bgcnt>>8)&0x1F);
					bgSizeX = textBgSize[0][bgcnt>>14];
					bgSizeY = textBgSize[1][bgcnt>>14];
				} else if (num==1) {
					bgColors = 1<<(4+((bgcnt>>5)&4));
					bgCharAdr = 0x4000 * ((bgcnt>>2)&0xF);
					bgScrAdr = 0x800 * ((bgcnt>>8)&0x1F);
					bgSizeX = textBgSize[0][bgcnt>>14];
					bgSizeY = textBgSize[1][bgcnt>>14];
				} else if (num==2) {
					bgColors = 1<<(4+((bgcnt>>5)&4));
					bgCharAdr = 0x4000 * ((bgcnt>>2)&0xF);
					bgScrAdr = 0x800 * ((bgcnt>>8)&0x1F);
					bgSizeX = textBgSize[0][bgcnt>>14];
					bgSizeY = textBgSize[1][bgcnt>>14];
				} else if (num==3) {
					if ((bgcnt&0x84)==0) {				// R/S
					} else if ((bgcnt&0x84)==0x80) {	// 256-color bmp
						bgSizeX = bmpBgSize[0][bgcnt>>14];
						bgSizeY = bmpBgSize[1][bgcnt>>14];
						bgColors = 256;
						bgScrAdr = 0x4000 * ((bgcnt>>8)&0x1F);
					} else if ((bgcnt&0x84)==0x84) {	// 32k-color bmp
						bgSizeX = bmpBgSize[0][bgcnt>>14];
						bgSizeY = bmpBgSize[1][bgcnt>>14];
						bgColors = 32768;
						bgScrAdr = 0x4000 * ((bgcnt>>8)&0x1F);
					}
				}
				break;
			case 4:
				bg0on = bg1on = bg2on = bg3on = 1;
				if (num==0) {
					bgColors = 1<<(4+((bgcnt>>5)&4));
					bgCharAdr = 0x4000 * ((bgcnt>>2)&0xF);
					bgScrAdr = 0x800 * ((bgcnt>>8)&0x1F);
					bgSizeX = textBgSize[0][bgcnt>>14];
					bgSizeY = textBgSize[1][bgcnt>>14];
				} else if (num==1) {
					bgColors = 1<<(4+((bgcnt>>5)&4));
					bgCharAdr = 0x4000 * ((bgcnt>>2)&0xF);
					bgScrAdr = 0x800 * ((bgcnt>>8)&0x1F);
					bgSizeX = textBgSize[0][bgcnt>>14];
					bgSizeY = textBgSize[1][bgcnt>>14];
				} else if (num==2) {
				} else if (num==3) {
					if ((bgcnt&0x84)==0) {				// R/S
					} else if ((bgcnt&0x84)==0x80) {	// 256-color bmp
						bgSizeX = bmpBgSize[0][bgcnt>>14];
						bgSizeY = bmpBgSize[1][bgcnt>>14];
						bgColors = 256;
						bgScrAdr = 0x4000 * ((bgcnt>>8)&0x1F);
					} else if ((bgcnt&0x84)==0x84) {	// 32k-color bmp
						bgSizeX = bmpBgSize[0][bgcnt>>14];
						bgSizeY = bmpBgSize[1][bgcnt>>14];
						bgColors = 32768;
						bgScrAdr = 0x4000 * ((bgcnt>>8)&0x1F);
					}
				}
				break;
			case 5:
				bg0on = bg1on = bg2on = bg3on = 1;
				if (num==0) {
					bgColors = 1<<(4+((bgcnt>>5)&4));
					bgCharAdr = 0x4000 * ((bgcnt>>2)&0xF);
					bgScrAdr = 0x800 * ((bgcnt>>8)&0x1F);
					bgSizeX = textBgSize[0][bgcnt>>14];
					bgSizeY = textBgSize[1][bgcnt>>14];
				} else if (num==1) {
				} else if (num==2) {
					if ((bgcnt&0x84)==0) {				// R/S
					} else if ((bgcnt&0x84)==0x80) {	// 256-color bmp
						bgSizeX = bmpBgSize[0][bgcnt>>14];
						bgSizeY = bmpBgSize[1][bgcnt>>14];
						bgColors = 256;
						bgScrAdr = 0x4000 * ((bgcnt>>8)&0x1F);
					} else if ((bgcnt&0x84)==0x84) {	// 32k-color bmp
						bgSizeX = bmpBgSize[0][bgcnt>>14];
						bgSizeY = bmpBgSize[1][bgcnt>>14];
						bgColors = 32768;
						bgScrAdr = 0x4000 * ((bgcnt>>8)&0x1F);
					}
				} else if (num==3) {
					if ((bgcnt&0x84)==0) {				// R/S
					} else if ((bgcnt&0x84)==0x80) {	// 256-color bmp
						bgSizeX = bmpBgSize[0][bgcnt>>14];
						bgSizeY = bmpBgSize[1][bgcnt>>14];
						bgColors = 256;
						bgScrAdr = 0x4000 * ((bgcnt>>8)&0x1F);
					} else if ((bgcnt&0x84)==0x84) {	// 32k-color bmp
						bgSizeX = bmpBgSize[0][bgcnt>>14];
						bgSizeY = bmpBgSize[1][bgcnt>>14];
						bgColors = 32768;
						bgScrAdr = 0x4000 * ((bgcnt>>8)&0x1F);
					}
				}
				break;
			case 6:
				bg0on = bg1on = bg3on = 0;
				bg2on = 1;
				if (num==2) {
					bgSizeX = (bgcnt&0x4000)?1024:512;
					bgColors = 256;
					bgSizeY = 1536 - bgSizeX;
					mapBg = 2;
				} else {
					bgSizeX = bgSizeY = -1;
				}
				break;
		}
	} else {
	}


	hCtl = GetDlgItem(hdlg,IDC_MSIZE);
	if (bgSizeX != -1)
		wsprintf(szBuffer,"%d*%d",bgSizeX,bgSizeY);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_MCOLORS);
	if (bgColors != -1)
		wsprintf(szBuffer,"%d",bgColors);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_MPRIO);
	if (bgPrio != -1)
		wsprintf(szBuffer,"%d",bgPrio);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_MSCR);
	if (bgScrAdr != -1)
		wsprintf(szBuffer,"0x%06x",bgScrAdr);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);

	hCtl = GetDlgItem(hdlg,IDC_MCHR);
	if (bgCharAdr != -1)
		wsprintf(szBuffer,"0x%06x",bgCharAdr);
	else
		wsprintf(szBuffer,"--");
	SetWindowText(hCtl,szBuffer);
}


// Map viewer callback
BOOL CALLBACK DlgProc18(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i,j,k,l;
	HWND hCmb,hCtl,hScroll;
	static unsigned char *surface=NULL;
	//static int bg0=0,bg1=0,bg2=0,bg3=0;
	static int mapCore=0;
	static int scrollH=0,scrollV=0;

   switch(msg) {
		case WM_INITDIALOG:
			SetWindowLong(hdlg, DWL_USER, lParam);
			mapdc = GetDC(hdlg);
			vramBank = (vram_bank*)mmu_get(MMU_VRAM_BANKS);

			if (!surface)
				surface = (unsigned char*)LocalAlloc(LPTR,256*192*2);
			ZeroMemory(surface,256*192*2);
			surfaceDib.data = (char*)surface;
			memset(&surfaceDib.bih,0,sizeof(BITMAPINFOHEADER));
 			surfaceDib.bih.biSize = sizeof(BITMAPINFOHEADER);
 			surfaceDib.bih.biWidth = 256;
 			surfaceDib.bih.biHeight = -192;
 			surfaceDib.bih.biPlanes = 1;
 			surfaceDib.bih.biBitCount = 16;
  			surfaceDib.bih.biCompression = BI_BITFIELDS;
			*((int*)&surfaceDib.colors[0]) = 0x001F;	// 00000000 000rrrrr
			*((int*)&surfaceDib.colors[1]) = 0x03E0;	// 000000gg ggg00000
			*((int*)&surfaceDib.colors[2]) = 0x7C00;	// 0bbbbb00 00000000

			/*UpdateBGProperties(hdlg,mapCore,0);
			UpdateBGProperties(hdlg,mapCore,1);
			UpdateBGProperties(hdlg,mapCore,2);
			UpdateBGProperties(hdlg,mapCore,3);*/
			UpdateBGProperties(hdlg,mapCore,mapBg);


			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
			ZeroMemory(&si4, sizeof(si4));
			si4.cbSize = sizeof(si);
			si4.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
			si4.nMin   = 0;
			si4.nMax   = (bgSizeX>256)?bgSizeX-256:0;
			si4.nPage  = 1;
			si4.nPos   = 0;
			SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);

			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR2);
			ZeroMemory(&si4, sizeof(si4));
			si4.cbSize = sizeof(si);
			si4.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
			si4.nMin   = 0;
			si4.nMax   = (bgSizeY>192)?bgSizeY-192:0;
			si4.nPage  = 1;
			si4.nPos   = 0;
			SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);

			hCtl = GetDlgItem(hdlg,IDC_RADIO1);
			EnableWindow(hCtl,bg0on);
			hCtl = GetDlgItem(hdlg,IDC_RADIO2);
			EnableWindow(hCtl,bg1on);
			hCtl = GetDlgItem(hdlg,IDC_RADIO_D3D);
			EnableWindow(hCtl,bg2on);
			hCtl = GetDlgItem(hdlg,IDC_RADIO3);
			EnableWindow(hCtl,bg3on);
			hCtl = GetDlgItem(hdlg,IDC_RADIO1+mapBg);
			if (IsWindowEnabled(hCtl))
				SendMessage(hCtl,BM_SETCHECK,1,0);

			hCtl = GetDlgItem(hdlg,IDC_COMBO1);
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Main");
			SendMessage(hCmb,CB_ADDSTRING,0,(LPARAM)"Sub");
			SendMessage(hCmb,CB_SETCURSEL,mapCore,0);
			EnableWindow(hCtl,bg0on+bg1on+bg2on+bg3on);

			RenderBG(hdlg,(unsigned short*)surface,mapCore,mapBg,scrollH,scrollV);

			return TRUE;


		case WM_SIZE:
			return 0;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);
			StretchDIBits(mapdc,200,16,256,192,0,0,256,192,
							  surfaceDib.data,(BITMAPINFO*)&surfaceDib.bih,DIB_RGB_COLORS,SRCCOPY);
			EndPaint(hdlg,&ps);
			break;

		case WM_HSCROLL:
			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
			if ((HWND)lParam != hScroll) return 0;

			scrollH = GetScrollPos(hScroll, SB_CTL);
			switch (LOWORD(wParam))
			{
				case SB_TOP:
					scrollH = 0;
					break;
				case SB_LINEUP:
					if (scrollH > 0)
						scrollH--;
					break;
				case SB_PAGEUP:
					if (scrollH > 1)
						scrollH -= 2;;
					break;
				case SB_THUMBPOSITION:
					scrollH = HIWORD(wParam);
					break;
				case SB_THUMBTRACK:
					scrollH = HIWORD(wParam);
					break;
				case SB_LINEDOWN:
					if (scrollH < bgSizeX-256)
						scrollH++;
					break;
				case SB_PAGEDOWN:
					if (scrollH < bgSizeX-257)
						scrollH += 2;
					break;
				case SB_BOTTOM:
					scrollH = (bgSizeX!=-1)?bgSizeX-256:0;
					break;
			}
			SetScrollPos(hScroll, SB_CTL, scrollH, TRUE);
			RenderBG(hdlg,(unsigned short*)surface,mapCore,mapBg,scrollH,scrollV);
			rect2.left = 200; rect2.top = 16;
			rect2.right = 288; rect2.bottom = 216;
			InvalidateRect(hdlg,&rect2,FALSE);
			return 0;

		case WM_VSCROLL:
			hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR2);
			if ((HWND)lParam != hScroll) return 0;

			scrollV = GetScrollPos(hScroll, SB_CTL);
			switch (LOWORD(wParam))
			{
				case SB_TOP:
					scrollV = 0;
					break;
				case SB_LINEUP:
					if (scrollV > 0)
						scrollV--;
					break;
				case SB_PAGEUP:
					if (scrollV > 1)
						scrollV -= 2;;
					break;
				case SB_THUMBPOSITION:
					scrollV = HIWORD(wParam);
					break;
				case SB_THUMBTRACK:
					scrollV = HIWORD(wParam);
					break;
				case SB_LINEDOWN:
					if (scrollV < bgSizeY-192)
						scrollV++;
					break;
				case SB_PAGEDOWN:
					if (scrollV < bgSizeY-193)
						scrollV += 2;
					break;
				case SB_BOTTOM:
					scrollV = (bgSizeY!=-1)?bgSizeY-192:0;
					break;
			}
			SetScrollPos(hScroll, SB_CTL, scrollV, TRUE);
			RenderBG(hdlg,(unsigned short*)surface,mapCore,mapBg,scrollH,scrollV);
			rect2.left = 200; rect2.top = 16;
			rect2.right = 288; rect2.bottom = 216;
			InvalidateRect(hdlg,&rect2,FALSE);
			return 0;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_RADIO1:
				case IDC_RADIO2:
				case IDC_RADIO_D3D:
				case IDC_RADIO3:
					mapBg = LOWORD(wParam)-IDC_RADIO1;
					UpdateBGProperties(hdlg,mapCore,mapBg);
					hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
					ZeroMemory(&si4, sizeof(si4));
					si4.cbSize = sizeof(si);
					si4.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
					si4.nMin   = 0;
					si4.nMax   = (bgSizeX>256)?bgSizeX-256:0;
					si4.nPage  = 1;
					si4.nPos   = 0;
					SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
					hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR2);
					ZeroMemory(&si4, sizeof(si4));
					si4.cbSize = sizeof(si);
					si4.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
					si4.nMin   = 0;
					si4.nMax   = (bgSizeY>192)?bgSizeY-192:0;
					si4.nPage  = 1;
					si4.nPos   = 0;
					SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
					RenderBG(hdlg,(unsigned short*)surface,mapCore,mapBg,scrollH,scrollV);
					InvalidateRect(hdlg,NULL,TRUE);
					return 0;

				case IDC_COMBO1:
					if (HIWORD(wParam)==CBN_SELCHANGE)
					{
						hCmb = GetDlgItem(hdlg,IDC_COMBO1);
						mapCore = SendMessage(hCmb,CB_GETCURSEL,0,0);
						UpdateBGProperties(hdlg,mapCore,mapBg);
						hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR1);
						ZeroMemory(&si4, sizeof(si4));
						si4.cbSize = sizeof(si);
						si4.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
						si4.nMin   = 0;
						si4.nMax   = (bgSizeX>256)?bgSizeX-256:0;
						si4.nPage  = 1;
						si4.nPos   = 0;
						SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
						hScroll = GetDlgItem(hdlg,IDC_SCROLLBAR2);
						ZeroMemory(&si4, sizeof(si4));
						si4.cbSize = sizeof(si);
						si4.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
						si4.nMin   = 0;
						si4.nMax   = (bgSizeY>192)?bgSizeY-192:0;
						si4.nPage  = 1;
						si4.nPos   = 0;
						SetScrollInfo(hScroll, SB_CTL, &si4, TRUE);
						RenderBG(hdlg,(unsigned short*)surface,mapCore,mapBg,scrollH,scrollV);
						InvalidateRect(hdlg,NULL,FALSE);
					}
					return 0;

				case IDC_BUTTON1:
					UpdateBGProperties(hdlg,mapCore,mapBg);
					RenderBG(hdlg,(unsigned short*)surface,mapCore,mapBg,scrollH,scrollV);
					InvalidateRect(hdlg,NULL,FALSE);
					return 0;

				case IDCANCEL:
				case IDCLOSE:
					if (surface)
					{
						LocalFree(surface);
						surface = NULL;
					}
					ReleaseDC(hdlg,mapdc);
					EndDialog(hdlg, 1);
					windows[12].active = false;
					return FALSE;

				default:
					break;
			}
			break;
   }

	return FALSE;
}

