#include "video.h"

BITMAPINFOHEADER aviBih;
CAVIGenerator	avigen;
char			*framebuffer;
int				aviFramesRecorded,aviFrameLimit=0;
int				aviFrameSelection;
int				recordMain=1,recordSub=1,aviRate=30;
char			szAviFn[256] = "c:\\dualis.avi";
bool			aviStreamCreated=false,aviIsRecording=false,aviCodecSelected=false;



void avi_setup()
{
	memset(&aviBih,0, sizeof(BITMAPINFOHEADER));
	// filling bitmap info structure.
	aviBih.biSize = sizeof(BITMAPINFOHEADER);
	aviBih.biWidth = 256;
	aviBih.biHeight = (recordMain && recordSub) ? 384 : 192;
	aviBih.biPlanes = 1;
	aviBih.biBitCount = 24;
	aviBih.biSizeImage = (((aviBih.biWidth*aviBih.biBitCount+31)/32)*4)*aviBih.biHeight;
	aviBih.biCompression = BI_RGB; //UYVY;

	// Set fps
	avigen.SetRate(aviRate);

	// Give info about bitmap
	avigen.SetBitmapHeader(&aviBih);
}


void avi_start_recording()
{
	if (aviIsRecording)
	{
		MessageBox(NULL,"Already recoding","AVI recorder",MB_ICONINFORMATION|MB_OK);
		return;
	}

	if ((!recordMain) && (!recordSub))
		return;

	avi_setup();

	// Set filename, extension ".avi" is appended if necessary
	//avigen.SetFileName(_T(szAviFn));

	if (!aviStreamCreated)
	{
		if (avigen.CreateStream() != AVIERR_OK)
		{
			MessageBox(NULL,"Failed to create stream","AVI recorder",MB_ICONERROR|MB_OK);
			return;
		}
		aviStreamCreated = true;
	}

	if (!aviCodecSelected)
	{
		if (avigen.CodecSelect() != AVIERR_OK)
		{
			MessageBox(NULL,"No compressor selected","AVI recorder",MB_ICONERROR|MB_OK);
			return;
		}
		aviCodecSelected = true;
	}

	if (avigen.PrepareStream() != AVIERR_OK)
	{
		return;
	}
	aviIsRecording = true;


	aviFramesRecorded = 0;

	if (recordMain)
	{
		if (recordSub)
			aviFrameSelection = GPU_FRAMEBUFFER_BGR24;
		else
			aviFrameSelection = GPU_FRAMEBUFFER_MAIN_BGR24;
	} else
		aviFrameSelection = GPU_FRAMEBUFFER_SUB_BGR24;
}



void avi_record_frame()
{
	if (aviIsRecording)
	{
		if ((!aviFrameLimit) || (aviFramesRecorded < aviFrameLimit))
		{
			aviFramesRecorded++;
			framebuffer = (char*)gpu_get(aviFrameSelection);
			if (framebuffer)
				avigen.AddFrame((BYTE*)framebuffer);
		}
	}
}


void avi_stop_recording()
{
	aviIsRecording = false;
	aviStreamCreated = false;
	avigen.ReleaseEngine();
}